/* BEGIN: Glossary */
function getGlossary() {
	$('#cont').html([
		'<div class="eAu-glossary">',
		'	<h1 class="eAu">Глоссарий</h1>',
		'	<form onsubmit="executeGlossaryQuery(); return false;" name="glossary-form" class="eAu-glossary-search-form">',
		'		<table border="0" cellspacing="0" cellpadding="0" width="100%">',
		'			<tr>',
		'				<td valign="middle" width="40%">',
		'					<input value="" type="text" id="glossary-input" class="eAu-input-text eAu-glossary-input" name="glossary-input" onkeydown="filterGlossaryByTimer();"/>',
		'				</td>',
		'				<td width="1">',
		'					<input type="image" src="images/buttons/search.gif" onclick="executeGlossaryQuery(); return false;" title="Найти" class="eAu-glossary-form-submit" />',
		'				</td>',
		'				<td></td>',
		'			</tr>',
		'		</table>',
		'	</form>',
		'	<div class="eAu-glossary-items" id="glossary-items-container"></div>',
		'</div>'
	].join('\n'));
	if (!arguments.callee.EntriesHash) {
		var Entries = [];
		var EntriesHash = {};
		var items = _Xml.select(head, '//glossary/text');
		for (var i = 0, length = items.length; i < length; ++i) {
			EntriesHash[_Xml.id(items[i])] = Entries.length;
			Entries.push({
				title: _Xml.title(items[i]) || '',
				id: _Xml.id(items[i]),
				item: items[i]
			});
		}
		arguments.callee.Entries = Entries;
		arguments.callee.EntriesHash = EntriesHash;
	}
	executeGlossaryQuery();
}
function filterGlossaryByTimer() {
	var ac = arguments.callee;
	if (!!ac.timeout) { clearTimeout(ac.timeout); }
	ac.timeout = setTimeout(function() {
		executeGlossaryQuery();
	}, 300);
}
function clearGlossaryFilterInput() {
	document.forms['glossary-form']['glossary-input'].value = '';
	executeGlossaryQuery();
	try {
		$('#glossary-input').focus();
	} catch (error) {}
}
function executeGlossaryQuery() {
	var value = (document.forms['glossary-form']['glossary-input'].value || '').toLowerCase();
	function startsWith(element, index, array) {
		return element.title.toLowerCase().indexOf(this) == 0;
	}
	function contains(element, index, array) {
		return element.title.toLowerCase().indexOf(this) != -1;
	}
	function filterEmpty(element, index, array) {
		return element.title == '';
	}
	function localeSort(val1, val2) {
		return val1.title.localeCompare(val2.title);
	}
	if (!value) {
		filteredEntries = getGlossary.Entries.concat([]).sort(localeSort);
	} else {
		if (value.length == 1) {
			filteredEntries = getGlossary.Entries.concat([]).filter(startsWith, value).sort(localeSort);
		} else {
			filteredEntries = getGlossary.Entries.concat([]).filter(contains, value).sort(localeSort);
		}
	}
	var emptyEntries = filteredEntries.filter(filterEmpty);
	var text = [];
	var firstChar;
	var fC;
	var li;
	for (var i = 0; i < filteredEntries.length; ++i) {
		if (filteredEntries[i].title == '') { continue; }
		fC = filteredEntries[i].title.charAt(0);
		if (firstChar != fC) {
			if (!firstChar) {
				firstChar = fC;
			} else {
				firstChar = fC;
				if (firstChar.match(/[A-Za-zА-Яа-я]/) && !firstChar.match(/\d/)) {
					text.push('<div class="eAu-glossary-group-delimiter"></div>');
				}
			}
		}
		li = 'glossary_text(\''+filteredEntries[i].id+'\', this); return false;';
		var div = Object.isUndefined(filteredEntries[i].text) ? '' : '<div id="eAu-glossary-item-'+ filteredEntries[i].id +'" class="eAu-glossary-item-description">'+ filteredEntries[i].text +'</div>';
		var link = Object.isUndefined(filteredEntries[i].text) ? '<a href="index.htm" onclick = "'+ li +'" target="_top" class="eAu-glossary-item-term">' + filteredEntries[i].title + '</a>' : '<h2 class="eAu">'+ filteredEntries[i].title +'</h2>';

		text.push('<div class="eAu-glossary-item">'+ link + div +'</div>');
	}
	if (emptyEntries.length) {
		text.push('<div class="eAu-glossary-group-delimiter"></div>');
	}
	for (var i = 0; i < emptyEntries.length; ++i) {
		li = 'glossary_text(\''+emptyEntries[i].id+'\', this); return false;';
		var div = Object.isUndefined(emptyEntries[i].text) ? '' : '<div id="eAu-glossary-item-'+ emptyEntries[i].id +'" class="eAu-glossary-item-description">'+ emptyEntries[i].text +'</div>';
		var link = Object.isUndefined(filteredEntries[i].text) ? '<a href="index.htm" onclick = "'+ li +'" target="_top" class="eAu-glossary-item-term"><i>не указано название термина</i></a>' : '<h2 class="eAu"><i>не указано название термина</i></h2>';
		text.push('<div class="eAu-glossary-item">'+ link + div +'</div>');
	}
	if (filteredEntries.length + emptyEntries.length == 0) {
		if (value.length == 1) {
			text.push('<div class="eAu-glossary-item"><div class="eAu-nothing-found">Слова, начинающиеся на букву «<b>'+ value +'</b>», отсутствуют в глоссарии<br />Попробуйте ввести больше символов, что-бы произвести поиск по подстроке, или <a href="index.htm" target="_top" onclick="clearGlossaryFilterInput(); return false;">произведите очистку поля поиска</a></div></div>');
		} else {
			text.push('<div class="eAu-glossary-item"><div class="eAu-nothing-found">Слова, содержащие подстроку «<b>'+ value +'</b>», отсутствуют в глоссарии<br />Попробуйте <a href="index.htm" target="_top" onclick="clearGlossaryFilterInput(); return false;">произвести очистку поля поиска</a></div></div>');
		}
	}
	$('#glossary-items-container').html('<div class="eAu-glossary-items">' + text.join('') + '</div>');
}
function loadGlossaryPageEx() {
	DS.unset('search');
	DS.unset('appendix-id');
	DS.set('glossary', '');
	loadingProxy();
}
/* END: Glossary */
