/**
 * @author betalb
 */

if (!self.eU) { self.eU = {}; }

jQuery.fn.identify = function(prefix, clobber) {
	if ( prefix == null || !prefix )
		prefix = "anonymous_element_";
	return this.each(function() {
		if ( !this.id || clobber )
			this.id = prefix + (++jQuery.fn.identify.index);
	});
};
jQuery.fn.identify.index = 0;

// Array.shuffle( deep ) - Randomly interchange elements
if (!Array.prototype.shuffle) {
	Array.prototype.shuffle = function(b) {
		var i = this.length, j, t;
		while( i ) {
			j = Math.floor( ( i-- ) * Math.random() );
			t = b && typeof this[i].shuffle!=='undefined' ? this[i].shuffle() : this[i];
			this[i] = this[j];
			this[j] = t;
		}
		return this;
	};
}

function pathMerge(base, relative) {
	base = base.replace(/\\/g, '/');
	relative = relative.replace(/\\/g, '/');
	if (relative.charAt(0) == '/') {
		relative = relative.substring(1, relative.length);
	}
	if (base.charAt(base.length - 1) == '/') {
		base = base.substring(0, base.length - 1);
	}
	return encodeURI(base + '/' + relative);
}

function getNodeText(node) {
	if (!Object.isUndefined(node.text)) {
		return node.text;
	}
	var strings = [];
	for (var i = 0, ims = node.childNodes, length = node.childNodes.length; i < length; ++i) {
		if (ims.item(i).nodeType == 4 || ims.item(i).nodeType == 3) {
			strings.push(ims.item(i).nodeValue);
		} else if (ims.item(i).childNodes && ims.item(i).childNodes.length) {
			strings.push(getNodeText(ims.item(i)));
		}
	}
	return strings.join(' ');
}

(function() {

if (!self.eAu) { self.eAu = {}; }
if (eAu.preloader) { return; }
//------------------------------------------------------------------------------
var handlers = {};
$.ajaxSetup({
	global: false
});
//------------------------------------------------------------------------------
function registerNewPreloader(extension, handler) {
	if (typeof handlers[extension] == "function") {
		return;
	}
	extension = extension.split(':')
	for (var i = 0, length = extension.length; i < length; ++i) {
		handlers[extension[i]] = handler;
	}
}
//------------------------------------------------------------------------------
function add(filename, callback, options) {
	options = $.extend({
		async: false,
		onError: function() {}
	}, options || {});
	var matches = filename.match(/\.([A-Za-z0-9\-_]+)$/);
	if (!matches || !matches[1]) { return; }
	if (!handlers[matches[1]]) {
		return 'Не зарегистрировано ни одного обработчика для расширения: "'+matches[1]+'"';
	}
	handlers[matches[1]].apply(null, [getLocalFilename(filename), callback, options]);
}
//------------------------------------------------------------------------------
registerNewPreloader('xml:php', function(filename, callback, options) {
	try {
		$.ajax({
			type: 'GET',
			url: filename,
			dataType: 'text',
			async: options.async,
			success: function(data) {
				if (!data) { callback(null); return; }

				var XmlData = (new DOMParser()).parseFromString(data, "text/xml");

				if (!XmlData || !XmlData.documentElement || /parsererror|html/.test(_Xml.name(XmlData.documentElement))) {
					callback(null); return;
				}

				try {
					XmlData.setProperty("SelectionLanguage", "XPath");
				} catch (error) {}

				callback(XmlData);
			},
			error: function(transport, status, error) {
				callback(null);
			}
		});
	} catch (error) {
		callback(null);
	}
});
//------------------------------------------------------------------------------
registerNewPreloader('xsl', function(filename, callback, options) {
	var tmpXslt = new XSLTProcessor();
	if (!tmpXslt) {
		callback(null)
		return;
	}
	try {
		$.ajax({
			type: 'GET',
			url: filename,
			dataType: 'text',
			async: options.async,
			success: function(data) {
				if (!data) { callback(null); return; }

				var XmlData = (new DOMParser()).parseFromString(data, "text/xml");

				if (!XmlData || !XmlData.documentElement || /parsererror|html/.test(_Xml.name(XmlData.documentElement))) {
					callback(null);
					return;
				}
				
				try {
					XmlData.setProperty("SelectionNamespaces", "xmlns:xsl='http://www.w3.org/1999/XSL/Transform'");
					XmlData.setProperty("AllowDocumentFunction", true);
					XmlData.resolveExternals = true;
				} catch (error) {}
				tmpXslt.importStylesheet(XmlData);
				callback(tmpXslt);
			},
			error: function(transport, status, error) {
				callback(null);
			}
		});
	} catch (error) {
		callback(null);
	}
});
//------------------------------------------------------------------------------
eAu.preloader = {
	add: function (filename, callback, options){
		if (!filename || filename == '' || !callback || typeof callback != 'function') { return false; }
		return add.apply(null, arguments);
	},
	register: function (extension, handler) {
		if (!extension || extension == '' || !handler) { return false; }
		return registerNewPreloader.apply(null, arguments);
	}
};

})();

(function() {

if (!self.eAu) { self.eAu = {}; }
if (eAu.Xml) { return; }

if (!eAu.options || !eAu.options.Xml) {
	if (!eAu.options) { eAu.options = {}; }
	eAu.options.Xml = {};
}

// Private methods
eAu._Xml = {
	isNode: function(object) {
		return object != null && !Object.isUndefined(object.nodeType);
	},
	isElement: function(object) {
		return isNode(object) && object.nodeType == 1;
	},
	isDocElement: function(el) {
		return isNode(el.parentNode) && el.parentNode.nodeType == 9;
	},
	readAttribute: function(el, attributeName) {
		return el.getAttribute(attributeName);
	},
	writeAttribute: function(el, attributeName, attributeValue) {
		return el.setAttribute(attributeName, attributeValue);
	},
	removeAttribute: function(el, attributeName) {
		return el.removeAttribute(attributeName);
	},
	parentElement: function(el) {
		return isElement(el.parentNode) ? el.parentNode : null;
	},
	select: function(el, options) {
		options = getSelectOptions(options);
		var func = options.single ? 'selectSingleNode' : 'selectNodes';
		var nodes = el[func](options.selector);
		if (options.single) {
			if (isElement(nodes)) { return nodes; }
			else { return null; }
		} else {
			var elements = [];
			for (var i = 0, length = nodes.length; i < length; ++i) {
				if (isElement(nodes.item(i))) {
					elements.push(nodes.item(i));
				}
			}
			return elements;
		}
	},
	isVisible: function(element, checkParents) {
		var el = element;
		if (!checkParents) {
			return readAttribute(el, opt.visibilityAttr) != opt.hidden;
		} else {
			while (el && isVisible(el) && !isDocElement(el)) {
				el = el.parentNode;
			}
			if (!isElement(el)) { return true; }
			return isVisible(el);
		}
	}
};
//------------------------------------------------------------------------------
var opt = Object.extend({
	visibilityAttr: 'visibility',
	groupAttr:      'group-text-nodes',
	srcAttr:        'src',
	idAttr:         'DB_ID',
	hidden:         'hidden',
	visible:        'visible'
}, eAu.options.Xml || {});
var opts = eAu.options;
//------------------------------------------------------------------------------
var isNode          = eAu._Xml.isNode;
var select          = eAu._Xml.select;
var isVisible       = eAu._Xml.isVisible;
var isElement       = eAu._Xml.isElement;
var isDocElement    = eAu._Xml.isDocElement;
var parentElement   = eAu._Xml.parentElement;
var readAttribute   = eAu._Xml.readAttribute;
var writeAttribute  = eAu._Xml.writeAttribute;
var removeAttribute = eAu._Xml.removeAttribute;
//------------------------------------------------------------------------------
function getFetchOptions(option) {
	var Options = {
		descendants: false,
		srcAttr: opt.srcAttr,
		onFinish: function() {}
	};
	if (Object.isString(option)) {
		Options.srcAttr = option.strip();
		if (Options.srcAttr == '') {
			return null;
		}
	} else if (Object.isBoolean(option)) {
		Options.descendants = option;
	} else if (Object.isObject(option)) {
		Options = Object.extend(Options, option);
	}
	return Options;
}
//------------------------------------------------------------------------------
function getTraversalOptions(option) {
	var Options = {
		visible: true,
		offset: 1,
		type: []
	};
	if (Object.isString(option)) {
		Options.type = option.strip().split(/\s+/);
	} else if (Object.isArray(option)) {
		Options.type = option;
	} else if (Object.isNumber(option)) {
		option = parseInt(option, 10);
		Options.offset = option;
	} else if (Object.isBoolean(option)) {
		Options.visible = option;
	} else if (Object.isObject(option)) {
		Options = Object.extend(Options, option || {});
	}
	Options.type = Object.isString(Options.type)
		? Options.type.strip().split(/\s+/)
		: Options.type;
	Options.offset = Options.offset == 0 ? 1 : Options.offset;
	return Options;
}
//------------------------------------------------------------------------------
function getSelectOptions(option) {
	var Options = {
		single: false,
		extend: true
	};
	if (Object.isString(option)) {
		Options.selector = option;
	} else if (Object.isObject(option)) {
		Options = Object.extend(Options, option);
	}
	if (Options.selector) { Options.selector = Options.selector.strip(); }
	return Options;
}
//------------------------------------------------------------------------------
function isGroupped(el) {
	var attr = readAttribute(el, opt.groupAttr);
	return attr !== 'false';
}
//------------------------------------------------------------------------------
function groupRoot(element) {
	// Проверка на Document Element не нужна,
	// т.к. parentElement вернёт null в качестве родителя
	var el = element;
	while (el && isVisible(el)) {
		el = parentElement(el);
		if (el && isGroupped(el)) { return el; }
	}
	return null;
}
//------------------------------------------------------------------------------
function groupRootGlobal(element) {
	var el = element;
	var root = null;
	while ( el && isVisible(el) ) {
		el = groupRoot(el);
		root = el ? el : root;
	}
	return root;
}
//------------------------------------------------------------------------------
function isOfType(el, types) {
	var isOfType = false;
	var selector, ElName, attrSelector;
	for (var i = 0, length = types.length; i < length; ++i) {
		ElName = name(el);
		if (types[i].indexOf('@') != -1) {
			selector = types[i].split('@');
			attrSelector = selector[1].split('=');
			isOfType = (selector[0] == ElName) && (readAttribute(el, attrSelector[0]) == attrSelector[1]);
		} else {
			isOfType = (ElName == types[i]);
		}
		if (isOfType) { break; }
	}
	return (types.length == 0)
		? true
		: isOfType;
}
//------------------------------------------------------------------------------
function npElement(element, dir) {
	var el = element;
	do {
		el = el[dir + 'Sibling'];
		if (!isNode(el)) { return null; }
	} while ( !isElement(el) );
	return el;
}
//------------------------------------------------------------------------------
function npOfType(element, types, dir) {
	var el = element;
	do {
		el = npElement(el, dir);
	} while ( el && !isOfType(el, types) );
	return el;
}
//------------------------------------------------------------------------------
function npVisible(element, types, dir) {
	var el = element;
	do {
		el = npOfType(el, types, dir);
	} while ( el && !isVisible(el) );
	return el;
}
//------------------------------------------------------------------------------
function childElement(el, dir) {
	var start = (dir == 'previous') ? el.lastChild : el.firstChild;
	if (!isNode(start)) { return null; }
	return isElement(start) ? start : npElement(start, dir);
}
//------------------------------------------------------------------------------
function childOfType(el, types, dir) {
	var start = childElement(el, dir);
	if (!isElement(start)) { return null; }
	return isOfType(start, types) ? start : npOfType(start, types, dir);
}
//------------------------------------------------------------------------------
function childVisible(el, types, dir) {
	var start = childOfType(el, types, dir);
	if (!isElement(start)) { return null; }
	return isVisible(start) ? start : npVisible(start, types, dir);
}
//------------------------------------------------------------------------------
function np(element, options, dir) {
	var el = element;
	var offset = Math.abs(options.offset);
	var func = options.visible ? npVisible : npOfType;
	do {
		el = func(el, options.type, dir);
	} while ( el && --offset > 0 );
	return el;
}
//------------------------------------------------------------------------------
function child(element, options, dir) {
	var offset = Math.abs(options.offset);
	var el = options.visible
		? childVisible(element, options.type, dir)
		: childOfType(element, options.type, dir);
	var func = options.visible ? npVisible : npOfType;
	while ( el && --offset > 0 ) {
		el = func(el, options.type, dir);
	}
	return el;
}
//------------------------------------------------------------------------------
function collect(element, options, dir) {
	var offset = Math.abs(options.offset);
	var el = options.visible
		? childVisible(element, options.type, dir)
		: childOfType(element, options.type, dir);
	var func = options.visible ? npVisible : npOfType;
	while ( el && --offset > 0 ) {
		el = func(el, options.type, dir);
	}
	var collected = [];
	while ( el ) {
		collected.push(el);
		el = func(el, options.type, dir);
	}
	return collected;
}
//------------------------------------------------------------------------------
function index(el, child, options) {
	var childs = collect(el, options, 'next');
	return {
		length: childs.length,
		index: (childs.indexOf(child)+1)
	};
}
//------------------------------------------------------------------------------
function parentOfType(element, types) {
	var el = element;
	do {
		el = parentElement(el);
	} while ( el && !isOfType(el, types) );
	return el;
}
//------------------------------------------------------------------------------
function parent(el, options) {
	var parent = el;
	// Маленькая оптимизация
	var func = (options.type.length == 0) ? parentElement : parentOfType;
	while (options.offset > 0 && parent) {
		parent = func(parent, options.type);
		options.offset--;
	}
	return parent;
}
//------------------------------------------------------------------------------
function parentOrSelf(el, options) {
	var parent = el;
	if (options.type.length == 0) {
		while (options.offset > 0 && parent) {
			parent = parentElement(parent);
			options.offset--;
		}
		return parent;
	}
	if (isOfType(parent, options.type)) {
		options.offset--;
	}
	// Маленькая оптимизация
	while (options.offset > 0 && parent) {
		parent = parentOfType(parent, options.type);
		options.offset--;
	}
	
	return parent;
}
//------------------------------------------------------------------------------
function name(el) {
	return el.nodeName.toLowerCase();
}
//------------------------------------------------------------------------------
function getRoot(el) {
	return el.ownerDocument;
}
//------------------------------------------------------------------------------
function addMethods(methods) {
	if (Object.isArray(methods)) {
		for (var i = 0; i < methods.length; ++i) {
			addTagMethods(arguments[1], methods[i]);
		}
		return;
	}
	for (var name in methods) {
		if (Object.isFunction(methods[name])) {
			XmlMethods[name] = methods[name];
		} else if (Object.isObject(methods[name]) && name == 'ByTag') {
			addMethodsByTag(methods[name]);
		}
	}
}
//------------------------------------------------------------------------------
var XmlMethods = {
	name: function(element) {
		return name(element);
	},
	attr: function(element, attrName, attrValue) {
		var el = element;
		if (arguments.length == 2) {
			return readAttribute(el, attrName);
		} else if (arguments.length > 2) {
			return writeAttribute(el, attrName, attrValue)
		}
	},
	hasAttr: function(node, attrName) {
		if (node.hasAttribute) {
			return node.hasAttribute(attrName);
		} else {
			for (var i = 0, length = node.attributes.length; i < length; ++i) {
				if (node.attributes.item(i).name == attrName) { return true; }
			}
		}
		return false;
	},
	next: function(element, options) {
		options = getTraversalOptions(options);
		if ( !(options.offset > 0) ) { return; }
		return np(element, options, 'next');
	},
	previous: function(element, options) {
		options = getTraversalOptions(options);
		if ( !(options.offset > 0) ) { return; }
		return np(element, options, 'previous');
	},
	neighbour: function(element, options) {
		options = getTraversalOptions(options);
		if ( options.offset == 0 ) { return; }
		var dir = (options.offset > 0) ? 'next' : 'previous';
		return np(element, options, dir);
	},
	child: function(element, options) {
		options = getTraversalOptions(options);
		if ( options.offset == 0 ) { return; }
		var dir = (options.offset > 0) ? 'next' : 'previous';
		return child(element, options, dir);
	},
	childs: function(element, options) {
		options = getTraversalOptions(options);
		if ( options.offset == 0 ) { return; }
		// Пригодится, что-бы указывать отступ
		// с которого начинать поиск
		var dir = (options.offset > 0) ? 'next' : 'previous';
		var childs = collect(element, options, dir);
		return childs;
	},
	index: function(element, child, options) {
		if ( !child ) { return null; }

		options = getTraversalOptions(options);
		if ( options.offset == 0 ) { return null; }
		return index(element, child, options);
	},
	indexOf: function(element, child, options) {
		if ( !child ) { return -1; }
		options = getTraversalOptions(options);
		if ( options.offset == 0 ) { return -1; }
		return index(element, child, options).index;
	},
	length: function(element, options) {
		options = getTraversalOptions(options);
		if ( options.offset == 0 ) { return; }
		return index(element, eAu.undefined, options).length;
	},
	parent: function(element, options) {
		options = getTraversalOptions(options);
		return parent(element, options);
	},
	parentOrSelf: function(element, options) {
		options = getTraversalOptions(options);
		return parentOrSelf(element, options);
	},
	isRoot: function(element) {
		return isDocElement(element);
	},
	is: function(element, selector) {
		if (!element) { return false; }
		return name(element) == selector;
	},
	select: function(element, options) {
		options = getSelectOptions(options);
		if ( !options.selector ) { return; }
		var elements = select(element, options);
		return elements;
	},
	$: function(element, id) {
		if ( !id ) { return null; }
		var ret = this.select(element, {
			single: true,
			selector: '//*[@'+ opt.idAttr +' = "'+ id +'"]'
		});
		return ret;
	},
	id: function(element) {
		return this.attr(element, opt.idAttr);
	},
	isVisible: function(element, checkParents) {
		return isVisible(element, !!checkParents);
	},
	isGroupped: function(element) {
		return isGroupped(element);
	},
	t: function(element) {
		return _Xml.title(element, true);
	},
	title: function(element, Short) {
		var BaseTitle = (this.attr(element, 'title') || 'нет заголовка').strip();
		var title = BaseTitle;
		if (['text', 'object'].indexOf(this.name(element)) != -1) {
			if (this.parent(element, 'glossary')) {
				title = (this.attr(element, 'title') || 'Глоссарий').strip();
			} else {
				title = (this.attr(_Xml.parent(element), 'title') || 'нет заголовка').strip();
				if (!this.isGroupped(_Xml.parent(element))) {
					var position = this.indexOf(_Xml.parent(element), element);
					var length = this.length(_Xml.parent(element));
					if (position != -1) {
						if (length > 1)
							title += ' (страница '+ position +' из '+ length +')';
					} else if (BaseTitle == '') {
						title = '';
					} else {
						title = BaseTitle;
					}
				}
			}
		} else if (this.name(element) == 'studiedproblem'
			&& !this.isGroupped(element) && !Short) {
			var length = this.length(element);
			if (length > 1) {
				title += ' (страница 1 из '+ length +')';
			}
		} else if (/^(question|question-exercise)$/.test(this.name(element))) {
			title = (this.attr(_Xml.parent(element), 'title') || 'нет заголовка').strip() + ' → ' + BaseTitle;
		}
		return title;
	},
	fetch: function(element, options) {
		options = getFetchOptions(options);
		var el = element;
		var nodes = options.descendants
			? select(el, 'descendant-or-self::*[@'+options.srcAttr+' and not(@'+options.srcAttr+'="")]')
			: [el];
		var src;
		for (var i = 0, length = nodes.length; i < length; ++i) {
			src = readAttribute(nodes[i], options.srcAttr);
			if (!src || !src.match(/(xml|php)$/)) { continue; }
			eAu.preloader.add(src, function(data) {
				if (!data || !data.documentElement) {
					var TextNodeWithError = getRoot(el).createTextNode('<div class="eU-error"><h2 class="eU-error-title">Невозможно отобразить часть содержимого</h2><div class="eU-error-text">Неудалось загрузить файл "<code>'+ src +'</code>" с сервера. Обратитесь к администрации ресурса или в службу тех. поддержки для устранения неисправностей.</div></div>');
					var ElementWithErrorText = getRoot(el).createElement('root');
					ElementWithErrorText.appendChild(TextNodeWithError);
					Sarissa.copyChildNodes(ElementWithErrorText, nodes[i]);
					return;
				}
				removeAttribute(nodes[i], options.srcAttr);
				Sarissa.copyChildNodes(data.documentElement, nodes[i]);
			});
		}
		return nodes;
	}
};
//------------------------------------------------------------------------------
XmlMethods.$$ = XmlMethods.select;
XmlMethods.item = XmlMethods.child;
XmlMethods.collect = XmlMethods.childs;
//------------------------------------------------------------------------------
eAu.Xml = XmlMethods;
self._Xml = eAu.Xml;

})();

eU.navigation = {
	findSiblings: function (element) {
		var result = { next: null, prev: null };
		if (!element) { return result; }
		if (!_Xml.isVisible(element)) { return result; }
		var validNodes = ['lesson', 'studiedproblem', 'studiedproblems', 'text', 'object', 'test'];
		if (validNodes.indexOf(_Xml.name(element)) == -1) {
			return result;
		}
		var isExpandable = function (expr, element) {
			return (Object.isFunction(expr)) ? expr(element) : !!expr;
		};
		if (!validStructure) {
			var validStructure = {
				lesson: {
					__: {
						expandable: true,
						childs: ['studiedproblem', 'studiedproblems', 'test']
					},
					studiedproblem: {
						__: {
							expandable: function(node, currentNode) {
								return !_Xml.isGroupped(node);
							},
							childs: ['text', 'object']
						},
						text: { __: {} },
						object: { __: {} }
					},
					studiedproblems: {
						__: {
							expandable: true,
							childs: ['studiedproblem']
						},
						studiedproblem: {
							__: {
								expandable: function(node) {
									return !_Xml.isGroupped(node);
								},
								childs: ['text', 'object']
							},
							text: { __: {} },
							object: { __: {} }
						}
					},
					test: { __: {} }
				}
			};
		}
		var cache = {
			type: _Xml.name(element),
			path: {
				xml: [],
				struct: [],
				invisible: null
			},
			struct: {
				root: validStructure.lesson,
				rootType: 'lesson'
			}
		};
		if (!cache.struct.root || cache.struct.rootType == cache.type) {
			return result;
		}
		var current = _Xml.parent(element);
		while(current
			&& cache.struct.rootType != _Xml.name(current)) {
			if (!cache.path.invisible && !_Xml.isVisible(current)) {
				cache.path.invisible = current;
			}
			cache.path.xml.push(current);
			current = _Xml.parent(current);
			
		}
		if (!current
				|| cache.struct.rootType != _Xml.name(current)) {
			return result;
		}
		cache.path.xml.push(current);
		var current0; // Текущий элемент XML дерева
		current = validStructure; // Текущий элемент структуры
		while (current0 = cache.path.xml.pop()) {
			var type = _Xml.name(current0);
			if (!current[type]) {
				return result;
			}
			if (!isExpandable(current[type].__.expandable, current0)) {
				return result;
			}
			if (cache.path.invisible == current0) cache.path.invisible = null;
			if (!cache.path.invisible) cache.path.struct.push(current[type]);
			current = current[type];
		};
		var preCurrent = { // Элементы структуры на которых закончили обход
			next: null,
			prev: null
		};
		current = element; // текущий элемент XML дерева
		// Ищем соседей, передвигаясь вверх по дереву
		while (current0 = cache.path.struct.pop()) {
			if (!result.next) {
				result.next = _Xml.next(current, current0.__.childs);
				preCurrent.next = current0;
			}
			if (!result.prev) {
				result.prev = _Xml.previous(current, current0.__.childs);
				preCurrent.prev = current0;
			}
			current = _Xml.parent(current);
			if (!!result.next && !!result.prev) break;
		};
		// Ищем соседей, спускаясь вниз, если это необходимо
		if (result.next) {
			do {
				var type = _Xml.name(result.next);
				if (isExpandable(preCurrent.next[type].__.expandable, result.next)) {
					result.next = _Xml.child(result.next, preCurrent.next[type].__.childs);
				} else { break; }
				preCurrent.next = preCurrent.next[type];
			} while (!!result.next);
		}
		if (result.prev) {
			do {
				var type = _Xml.name(result.prev);
				if (isExpandable(preCurrent.prev[type].__.expandable, result.prev)) {
					if (preCurrent.prev[type].__.goToFirst) {
						result.prev = _Xml.child(result.prev, preCurrent.prev[type].__.childs);
					} else {
						result.prev = _Xml.child(result.prev, { type: preCurrent.prev[type].__.childs, offset: -1 });
					}
				} else { break; }
				preCurrent.prev = preCurrent.prev[type];
			} while (!!result.prev);
		}
		return result;
	}
};

function getLocalFilename(filename) {
	if (filename.indexOf('://') != -1) {
		return filename;
	}
	var dlh = document.location.pathname.replace(/\\/g, '/').split('/');
	dlh.pop();
	dlh.push(filename);
	return document.location.protocol + '//' + document.location.host + dlh.join('/');
}

function inDOM() {
	return !!_Xml.parentOrSelf(this, 'body');
}

function attachDOM3EventOnNodeInsertedAddHandler(event) {
	var node = event.target;
	if (node && node.onload) {
		node.onload.call(node);
	}
}
function attachDOM3EventOnNodeInsertedRemoveHandler(event) {
	var node = event.target;
	if (!node) { return; }
	
	node.removeEventListener('DOMNodeInsertedIntoDocument', attachDOM3EventOnNodeInsertedAddHandler, true);
	node.removeEventListener('DOMNodeRemovedFromDocument', attachDOM3EventOnNodeInsertedRemoveHandler, true);
}

function attachDOM3EventOnNodeInserted() {
	if (!this.addEventListener || inDOM.call(this)) { return; }
	
	this.addEventListener('DOMNodeInsertedIntoDocument', attachDOM3EventOnNodeInsertedAddHandler, true);
	this.addEventListener('DOMNodeRemovedFromDocument', attachDOM3EventOnNodeInsertedRemoveHandler, true);
}

function transformToTextEx(element, stylesheet, options) {
	if (!stylesheet) { return; }

	stylesheet.clearParameters();
	options = Object.extend({
		'transformed-element-id': _Xml.id(element)
	}, options || {});

	for (var param in options) {
		if (!Object.isString(options[param]) || !param) { continue; }
		stylesheet.setParameter(null, param, options[param]); 
	}

	var output = stylesheet.transformToFragment(element, document);

	if (output && output.firstChild) {
		var fc = output.firstChild;
		output = document.createElement('div');
		output.appendChild(fc);
	} else {
		output = null;
	}

	try {
		if (output) {
			return Sarissa.unescape(output.innerHTML);
		} else {
			return '<div>ERROR</div>';
		}
	} finally {
		output = null;
	}
}

// Обработка внутренних ссылок
function checkInnerLinks(event) {
	function isA(n) {
		return !!n && (n.nodeName == 'A' || n.nodeName == 'a');
	}

	var target = event.target;

	var i = 0;
	while (target || i < 5) {
		++i;
		if (isA(target)) {
			break;
		}
		target = _Xml.parent(target);
	}

	if (!target || !isA(target)) {
		return;
	}

	var isInnerLink = false;
	var linkId;
	if ((_Xml.attr(target, 'href') || '').indexOf('index.htm') != -1
		&& _Xml.attr(target, 'eAu_processed') != 'yes'
		&& (_Xml.attr(target, 'onclick') || '').toString().indexOf('link_info') != -1) {
		var oc = _Xml.attr(target, 'onclick').toString();
		oc = oc.substr(oc.indexOf('link_info') + 11);
		linkId = oc.substring(0, oc.indexOf("'"));
	} else if (_Xml.attr(target, 'InnerLink')) {
		isInnerLink = true;
		linkId = _Xml.attr(target, 'InnerLink');
		linkId = linkId.indexOf('EUL:') == 0 ? linkId.substr(4) : linkId;

		_Xml.attr(target, 'InnerLink', '');
	} else {
		return;
	}

	var element = _Xml.$(head, linkId);
	var targetElement = getTargetNode(element);
	var isAccessible = !!element && checkRights(targetElement) && canNavigateToNodeOnServer(element);

	var h2 = _Xml.parent(target, 'h2');
	if (h2 && !isAccessible && !$(_Xml.parent(h2)).is('.eAu-access-forbidden-links')) {
		$(_Xml.parent(h2))
			.addClass('eAu-access-forbidden-links')
	}

	$(target)
		.attr('title', 'Раздел не найден')
		.attr('href', 'index.htm')
		.attr('target', '_top')
		.attr('eAu_processed', 'yes');

	if (!$(target).is('.inner-link')) {
		$(target)
			.addClass('inner-link');
	}

	if (!element) {
		target.onclick = function() {
			return false;
		}
	}

	$(target)
		.attr('title', !isAccessible ? (element ? 'Раздел недоступен к изучению' : 'Раздел не найден') : _Xml.title(element));

	if (!isAccessible && !$(target).is('.eAu-access-forbidden-link')) {
		$(target)
			.addClass('eAu-access-forbidden-link');
		
	} else if (isAccessible && !$(target).is('.eAu-access-allowed-link')) {
		$(target)
			.addClass('eAu-access-allowed-link')
	}

	if (isInnerLink && element) {
		target.onclick = function() {
			processInnerLinks(target, _Xml.id(element));
			return false;
		}
	}
}

function checkLink(event) {
	function isA(n) {
		return !!n && (n.nodeName == 'A' || n.nodeName == 'a');
	}

	var target = event.target;

	if (!target || !isA(target)) {
		return;
	}

	var linkId = _Xml.attr(target, 'db-id');
	var target = $(target);

	var element = _Xml.$(head, linkId);
	var isAccessible = !!element && checkRights(element) && canNavigateToNodeOnServer(element);

	target
		.attr('title', !isAccessible ? 'Раздел недоступен к изучению' : _Xml.title(element))

	if (isAccessible && target.is('.eAu-access-forbidden-link')) {
		target.removeClass('eAu-access-forbidden-link');
	}
	if (!isAccessible && !target.is('.eAu-access-forbidden-link')) {
		target.addClass('eAu-access-forbidden-link');
	}
}
