Element.addMethods({
	swapClassName: function(element, class1, class2) {
		if (element.hasClassName(class1)) {
			Element
				.removeClassName(element, class1)
				.addClassName(class2);
		} else {
			Element
				.removeClassName(element, class2)
				.addClassName(class1);
		}
		return element;
	}
});
jQuery.fn.swapClass = function(c1, c2){
	return this.each(function() {
		if (jQuery.className.has(this, c1)) {
			jQuery.className.remove(this, c1);
			jQuery.className.add(this, c2);
		} else {
			jQuery.className.remove(this, c2);
			jQuery.className.add(this, c1);
		}
	});
}
Element.addMethods({
	hasFlag: function(element, property) {
		return !Object.isUndefined(element[property]);
	},
	addFlag: function(element, property) {
		if (Object.isUndefined(element[property])) {
			element[property] = true;
		}
		return element;
	}
});

/**
 * Adapted for Prototype based on:
 * http://forums.microsoft.com/MSDN/ShowPost.aspx?PostID=2847218&SiteID=1
 */
//Element.removeWithoutLeakProtection = Element.Methods.remove;
Element.addMethods({
	discard: function(element){
		element = $P(element);
		var garbageBin = $P('IELeakGarbageBin') || document.body.appendChild(
			new Element('div', { id:'IELeakGarbageBin', style:'display:none;' })
		);
		garbageBin.appendChild(element);
		garbageBin.innerHTML = '';
		return element;
	}
});

window.WindowEvent = (function() {
	var cache = {};
	var eventNames = [];
	function callUnload() {
	}
	Event.observe(window, 'unload', function(event) {
		if (!cache['unload']) { return; }
		for (var i = 0, length = cache['unload'].length; i < length; ++i) {
			cache['unload'][i].call(null, event);
		}
	});
	return {
		destroy: function() {
			eventNames.each(function(eventName) {
				cache[eventName].each(function(f) {
					Event.stopObserving(window, eventName, f);
				});
			});
			delete eventNames;
			delete cache;
		},
		observe: function(eventName, handler) {
			if (!cache[eventName]) {
				cache[eventName] = [];
				if (eventName != 'unload') {
					eventNames.push(eventName);
				}
			}
			if (cache[eventName].indexOf(handler) == -1) {
				cache[eventName].push(handler);
				if (eventName != 'unload') {
					Event.observe(window, eventName, handler);
				}
			}
		},
		fire: function(eventName, args) {
			if (!cache[eventName]) { return; }
			cache[eventName].each(function(f){
				f.call(window, args);
			});
		},
		stopObserving: function(eventName, handler) {
			if (!cache[eventName]) { return; }
			cache[eventName].each(function(f) {
				Event.stopObserving(window, eventName, f);
			});
			var index = eventNames.indexOf(eventName);
			eventNames.splice(index, 1);
			delete cache[eventName];
		}
	};
})();

/* treeview helper functions */
function getNodeText(node) {
	var ret = [], node0;
	for(var i = 0; i < node.childNodes.length; i++) {
		node0 = node.childNodes[i];
		if (node0.nodeType == 3) {
			ret.push(node0.nodeValue);
		} else if (node0.nodeType == 1 && node0.nodeName.toLowerCase() == 'a') {
			ret.push(getNodeText(node0));
		}
	}
	return ret.join("");
}
function getRequestUrl(element) {
	var url;
	function getUrl(el) {
		return el ? (el.readAttribute('url') || '').strip() : '';
	}
	while (element) {
		url = getUrl(element);
		if (url != '') { return url; }
		if (element.hasClassName('tree-view')) { return null; }
		element = element.up();
	}
	return null;
}

window.eLS = (function() {
	var ImagesPreloadQueue = {};
	var ImagesPreloadScopes = [];
	var events = ['selectstart', 'dragstart', 'dblclick', 'mousedown', 'contextmenu'];
	var unblockedElements = ['input', 'button', 'textarea', 'select', 'option'];
	function findStylesheet() {
		// Finding stylesheet with custom colors
		var styleSheet = null;
		if (document.styleSheets) {
			for (var i = 0; i < document.styleSheets.length; ++i) {
				var Sheet = document.styleSheets[i];
				if (Sheet.href && Sheet.href.indexOf('skin.css.php') != -1) {
					styleSheet = Sheet;
					break;
				}
			}
		}
		return styleSheet;
	}
	function getCurrentTab() {
		if (top.name.indexOf('180302') != -1) {
			return '02';
		}
		if (top.name.indexOf('180303') != -1) {
			return '03';
		}
		if (top.name.indexOf('180304') != -1) {
			return '04';
		}
		return '01';
	}
	function from10toradix(value, radix) {
		var retval = '';
		var ConvArray = [
			'0', '1', '2', '3',
			'4', '5', '6', '7',
			'8', '9', 'A', 'B',
			'C', 'D', 'E', 'F'
		];
		var intnum;
		var tmpnum;
		var i = 0;
		intnum = parseInt(value, 10);
		if (isNaN(intnum)) {
			retval = 'NaN';
		} else {
			while (intnum > 0.9) {
				i++;
				tmpnum = intnum;
				// cancatinate return string with new digit:
				retval = ConvArray[tmpnum % radix] + retval;
				intnum = Math.floor(tmpnum / radix);
				if (i > 100) {
					// break infinite loops
					retval = 'NaN';
					break;
				}
			}
		}
		return retval;
	}
	function insertZeroes(str, length) {
		length = length || 2;
		if (str.length >= length) { return str; }
		var stringArray = [];
		for (var i = 0; i < length - str.length; ++i) {
			stringArray.push('0');
		}
		return stringArray.join('') + str;
	}
	function rgb2hex(color) {
		color = color.substr(4, color.length - 5).split(',');
		for (var i = 0; i < color.length; ++i) {
			color[i] = insertZeroes(from10toradix(color[i], 16));
		}
		return '#' + color.join('');
	}
	var ColorPickerWindow, ColorFields = {}, CurrentColors = [];
	WindowEvent.observe('unload', function() {
		try {
			if (ColorPickerWindow && ColorPickerWindow.eLS) {
				ColorPickerWindow.close();
			}
		} catch (error) {}
		ColorPickerWindow = null;
			
	});
	return {
		cache: {
			observed: [],
			domNodes: {}
		},
		utils: {
			ColorPicker: {
				show: function() {
					try {
						if (ColorPickerWindow && ColorPickerWindow.eLS) {
							ColorPickerWindow.focus();
						} else {
							throw 'error';
						}
					} catch (error) {
						ColorPickerWindow = window.open(serverSkinURL+'colorpicker.html', 'colorpicker', 'HEIGHT=700,WIDTH=500');
						ColorPickerWindow.focus();
					}
				},
				init: function() {
					$P(document).observe('tabs:changed', function(event) {
						function reloadData(colors) {
							eLS.utils.ColorPicker.apply(colors);
							try {
								if (ColorPickerWindow && ColorPickerWindow.eLS) {
									ColorPickerWindow.eLS.utils.ColorPicker.setColors(colors);
								} else {
									throw '';
								}
							} catch (error) {
							} finally {}
						}
						if (event.element().id != 'content-tabs-controller') { return; }
						var _tab = getCurrentTab();
						if (arguments.callee._tab == _tab) { return; }
						arguments.callee._tab = _tab;
						if (!ColorFields['color1_' + _tab]) {
							ColorFields['color1_' + _tab] = $P('color1_' + _tab);
							ColorFields['color2_' + _tab] = $P('color2_' + _tab);
						}
						var colorField = [
							ColorFields['color1_' + _tab],
							ColorFields['color2_' + _tab]
						];
						if (!colorField[0] || !colorField[1]) { return; }
						if (colorField[0].value && colorField[1].value) {
							reloadData([colorField[0].value, colorField[1].value]);
							return;
						}
						//     ,     CSS
						var styleSheet = findStylesheet();
						var colors = ['', ''];
						if (!styleSheet) { return; }
						var cssRules = styleSheet.rules ? styleSheet.rules : styleSheet.cssRules;
						if (cssRules[0].selectorText.indexOf('ie-rule-marker-color-1') != -1) {
							colors[0] = cssRules[0].style.color;
						}
						for (var i = 1; i < cssRules.length; ++i) {
							if (cssRules[i].selectorText.indexOf('ie-rule-marker-color-2') != -1) {
								colors[1] = cssRules[i].style.color;
								break;
							}
						}
						if (!colors[0] || !colors[1]) { return; }
						if (colors[0].indexOf('rgb') != -1) {
							colors[0] = rgb2hex(colors[0]);
							colors[1] = rgb2hex(colors[1]);
						}
						colorField[0].value = colors[0].toUpperCase();
						colorField[1].value = colors[1].toUpperCase();
						reloadData(colors);
					});
				},
				apply: function(colors) {
					colors = colors || [];
					var styleSheet = findStylesheet();
					var _tab = getCurrentTab();
					var colorField;
					if (!styleSheet) { return; }
					if (!ColorFields['color1_' + _tab]) {
						ColorFields['color1_' + _tab] = $P('color1_' + _tab);
						ColorFields['color2_' + _tab] = $P('color2_' + _tab);
					}
					if (CurrentColors[0] == colors[0] && CurrentColors[1] == colors[1]) {
						return;
					}
					if (!colors[0] || !colors[1]) { return; }
					CurrentColors = colors;
					if (ColorFields['color1_' + _tab] && ColorFields['color2_' + _tab]) {
						ColorFields['color1_' + _tab].value = colors[0];
						ColorFields['color2_' + _tab].value = colors[1];
					} else {
						return;
					}
					var cssRules = styleSheet.rules ? styleSheet.rules : styleSheet.cssRules;
					var currentColor = colors[0];
					var styleProperty = '';
					for (var i = 0; i < cssRules.length; ++i) {
						if (cssRules[i].selectorText.indexOf('ie-rule-marker-color-2') != -1) {
							currentColor = colors[1];
							styleProperty = cssRules[i]
								.selectorText
								.split(',')
								.invoke('strip')
								.first();
						} else if (cssRules[i].selectorText.indexOf('ie-rule-marker-color-1') != -1) {
							currentColor = colors[0];
							styleProperty = cssRules[i]
								.selectorText
								.split(',')
								.invoke('strip')
								.first();
						}
						if (styleProperty) {
							styleProperty = styleProperty.replace(/\.ie-rule-marker-color-(1|2)-/, '');
							if (styleProperty.indexOf('ie-rule-marker-color-') != -1) {
								styleProperty = '';
							}
							styleProperty = styleProperty.camelize();
						}
						setTimeout(function(myColor, selector) {
							if (this.style.color) {
								this.style.color = myColor;
							} else if (this.style.backgroundColor) {
								this.style.backgroundColor = myColor;
							} else if (this.style.borderTopColor) {
								this.style.borderTopColor = myColor;
							}
						}.bind(cssRules[i], currentColor, styleProperty), Math.floor(Math.random()*50));
					}
				}
			},
			contentBlocker: {
				enable: function(obj) {
					var $document = $P(document);
					events.each(function(eventName) {
						$document.observe(eventName, function(e) {
							if (e.element() && unblockedElements.indexOf((e.element().nodeName || '').toLowerCase()) == -1)  {
								e.stop();
								return false;
							}
							return true;
						});
					});
					/*@cc_on @*/
					/*@if (@_win32)
						WindowEvent.observe('load', function() {
							var images = document.getElementsByTagName("img");
							if (!images) { return; }
							for (var i = 0, length = images.length; i < length; ++i) {
								images[i].setAttribute("galleryimg", "no");
							}
						});
					/*@end @*/
					WindowEvent.observe('unload', function() {
						events.each(function(eventName) {
							$document.stopObserving(eventName);
						});
					});
				}
			},
			ImagesPreload: {
				add: function (src, scope, options) {
					options = Object.extend({
						onload:  Prototype.K,
						onerror: Prototype.K
					}, options || {});
					function find (v) { return v.src == src; }
					if (!ImagesPreloadQueue[scope]) {
						ImagesPreloadQueue[scope] = [];
						ImagesPreloadScopes.push(scope);
					}
					if (ImagesPreloadQueue[scope].find(find)) { return false; }
					var o = {
						image: new Image(),
						src: src
					};
					ImagesPreloadQueue[scope].push(o);
					var index = ImagesPreloadQueue[scope].length - 1;
					o.image.onerror = function() {
						ImagesPreloadQueue[scope][index].image = null;
						options.onerror(ImagesPreloadQueue[scope][index].src);
					};
					o.image.onload = function () {
						options.onload(ImagesPreloadQueue[scope][index].image);
					};
					o.image.src = src;
				},
				unload: function() {
					ImagesPreloadScopes.each(function(scope) {
						for (var i = 0, length = ImagesPreloadQueue[scope].length; i < length; ++i) {
							if (ImagesPreloadQueue[scope][i]) {
								ImagesPreloadQueue[scope][i].image = null;
								ImagesPreloadQueue[scope][i] = null;
							}
						}
						ImagesPreloadQueue[scope] = null;
					});
					delete ImagesPreloadQueue;
					delete ImagesPreloadScopes;
				}
			},
			form: {
				submit: function(context, t) {}
			},
			init: function() {
				var loginForm = $P('loginForm');
				if (loginForm) {
					function checkLoginData() {
						var domNodes = eLS.cache.domNodes;
						if (!domNodes.login || !domNodes.password) {
							domNodes.login =    $P('login');
							domNodes.password = $P('password');
						}
						return !!domNodes.login && !!domNodes.password
							&& !!domNodes.login.value.strip()
							&& !!domNodes.password.value.strip();
					}
					function reportInvalidInput() {
						var domNodes = eLS.cache.domNodes;
						if (!domNodes.login || !domNodes.password) {
							domNodes.login =    $P('login');
							domNodes.password = $P('password');
						}
						if (domNodes.login && !domNodes.login.value.strip()) { domNodes.login.highlight({startcolor: '#FF0000'}); }
						if (domNodes.password && !domNodes.password.value.strip()) { domNodes.password.highlight({startcolor: '#FF0000'}); }
					}
					loginForm
						.observe('click', function() {
							var domNodes = eLS.cache.domNodes;
							if (!domNodes.localtime) {
								domNodes.localtime = $P('localtime');
							}
							if (!domNodes.localtime) { return; }
							domNodes.localtime.value = Math.round((new Date()).getTime()/1000);
						})
						.observe('submit', function(event) {
							if (!checkLoginData()) {
								reportInvalidInput();
								event.stop();
								return false;
							}
						})
						.observe('keypress', function(event) {
							if (event.keyCode == 13 && checkLoginData()) {
								this.submit();
							} else if (event.keyCode == 13) {
								reportInvalidInput();
							}
						});
					var loginButton = $P('loginButton');
					if (loginButton) {
						loginButton.observe('click', function(event) {
							if (checkLoginData()) {
								loginForm.submit();
								event.stop();
							} else {
								reportInvalidInput();
							}
						});
					}
				}
				//  
				var toolbarNodes = ['tb-navigation-previous',
				 'tb-navigation-next',
				 'tb-navigation-reload',
				 'tb-window-close'];
				var toolbarNode;
				for (var i = 0; i < toolbarNodes.length; ++i) {
					toolbarNode = $P(toolbarNodes[i])
					if (!toolbarNode) { continue; }
					switch (toolbarNodes[i]) {
					case 'tb-navigation-previous':
						toolbarNode.observe('click', function(event) { event.stop(); history.back(); });
						break;
					case 'tb-navigation-next':
						toolbarNode.observe('click', function(event) { event.stop(); history.forward(); });
						break;
					case 'tb-navigation-reload':
						toolbarNode.observe('click', function(event) { event.stop(); document.location.reload(); });
						break;
					case 'tb-window-close':
						toolbarNode.observe('click', function(event) {
							var win = window;
							while (win.parent && win != win.parent) {
								win = win.parent;
							}
							if (win) {
								event.stop();
								win.close();
							}
						});
						break;
					}
				}
				eLS.utils.ColorPicker.init();
			},
			navigate: function(href) {
				document.location.href = href;
			},
			filter: function(context) {
				eLS.utils.form.submit(context);
			},
			showMessageBox: function(header, content) {
				var domNodes = eLS.cache.domNodes;
				if (!domNodes.box || !domNodes.header || !domNodes.content) {
					domNodes.box     = $P('alert-message-box');
					domNodes.header  = $P('message-box-header');
					domNodes.content = $P('message-box-content');
				}
				if (domNodes.header) {
					if (header) { domNodes.header.update(header); }
					else { domNodes.header.update(''); }
				}
				if (domNodes.content) {
					if (content) { domNodes.content.update(content); }
					else { domNodes.content.update(''); }
				}
				if (domNodes.box) {
					domNodes.box.show();
					var up = domNodes.box.up();
					if (up && up.hasClassName('root-message-box-wrapper')) {
						up.show();
					}
				}
				eLS.utils.messageBox();
				try {
					domNodes.box.down('.button > a').focus();
				} catch (error) {}
			},
			messageBox: function(handler) {
				var domNodes = eLS.cache.domNodes, offsets;
				if (!domNodes.overlay || !domNodes.html || domNodes.iframeShim) {
					domNodes.overlay    = $P('message-box-overlay');
					domNodes.html       = document.getElementsByTagName('html')[0];
					domNodes.iframeShim = $P('iframe-shim');
				}
				if (domNodes.html) {
					$P(domNodes.html).addClassName('no-overflow');
				}
				offsets = document.viewport.getScrollOffsets();
				if (domNodes.overlay && domNodes.iframeShim) {
					[domNodes.overlay, domNodes.iframeShim]
						.invoke('setStyle', {
							top:  ''+ offsets.top  +'px',
							left: ''+ offsets.left +'px'
						})
						.invoke('show');
				}
				var messageBoxes = $A(document.getElementsByClassName('root-message-box'));
				var box;
				for (var j = 0, length = messageBoxes.length; j < length; ++j) {
					box = $P(messageBoxes[j]);
					box.setStyle({
						top:  ''+ offsets.top  +'px',
						left: ''+ offsets.left +'px'
					});
					var up = box.up();
					if (up && up.hasClassName('root-message-box-wrapper')) {
						up.show();
					}
					var close = box.getElementsByClassName('close');
					if (!close || !close.length) { return; }
					for (var i = 0; i < close.length; ++i) {
						if (close[i].observed) { continue; }
						close[i].observed = true;
						close[i].observe('click', function(event) {
							var $this = $P(this);
							var a = $this.down('a');
							if (a && (a.readAttribute('href') || ' ').match(/^javascript/)) {
								event.stop();
								if (domNodes.overlay && domNodes.iframeShim) {
									[domNodes.overlay, domNodes.iframeShim]
										.invoke('hide');
								}
								$A(document.getElementsByClassName('root-message-box')).each(function(el) {
									var up = el.up();
									if (up && up.hasClassName('root-message-box-wrapper')) {
										up.hide();
									}
									$P(el).hide();
								});
								if (domNodes.html) {
									$P(domNodes.html).removeClassName('no-overflow');
								}
								if (handler) { handler(event); }
								WindowEvent.fire('resize');
							}
						});
					}
				}
			},
			closeSelfRefreshOpener: function() {
				window.close();
				opener.location.reload();
			},
			closeSelfGoUrlOpener: function(globalOpenerURL) {
				opener.location.href = globalOpenerURL;
				window.close();
			},
			refreshSelf: function() {
				window.location.reload();
			},
			goBack: function() {
				history.go(-1);
			},
			getTreeviewXML: function(treeviewDivId, level) {
				level = Object.isUndefined(level) ? 0 : (parseInt(level, 10) || 0);
				var xml = [];
				var attrs = [],
				    check = ['id', 'cid', 'run_id', 'bid', 'tid'];
				var walkAroundTheList = function(ul) {
					ul.childElements().each(function(li) {
						if (!li.match('li')) { return; }
						var ul = li.down('ul');

						attrs = [];

						var addTitle = false;
						for (var i = 0; i < check.length; i++) {
							var attrName = check[i]
							var attrValue = li.readAttribute(attrName)

							if ((i == 0 && !attrValue) || (i > 1 && attrValue)) {
								addTitle = true;
							}

							if (attrValue) {
								attrs.push(attrName+'="'+ attrValue +'"');
							}
						}

						if (li.hasFlag('changed-inside')) {
							attrs.push('changedInside="true"');
						}

						//addTitle = addTitle || li.hasClassName('title-changed') || li.hasClassName('root');
						addTitle = addTitle || li.hasFlag('title-changed') || level == 0;
						if (addTitle) {
							attrs.push('title="'+ getNodeText(li).strip() +'"');
						}

						xml.push('<item '+ attrs.join(' ') + (ul ? ' ' : ' /')+'>');
						if (ul) {
							walkAroundTheList(ul, level + 1);
							xml.push('</item>');
						}
					});
				}
				walkAroundTheList($P(treeviewDivId).down('ul'));
				return xml.join('');
			},
			sendTreeviewXML: function(treeviewDivId, url) {
				var xml = eLS.utils.getTreeviewXML(treeviewDivId);
				new Ajax.Request(url, {
					method: 'post',
					postBody: xml,
					onSuccess: function() {
						eLS.utils.showMessageBox('', ' .');
					},
					onFailure: function() {
						eLS.utils.showMessageBox('', '   !');
					},
					onException: function() {
						eLS.utils.showMessageBox('', '   !');
					}
				});
			}
		}
	};
})();

(function() {
var DOMContentLoadedCallback = function() {
	eLS.utils.init();
	eLS.utils.ImagesPreload.add(serverSkinURL+'images/content/header-bg.png', 'content');
	eLS.utils.ImagesPreload.add(serverSkinURL+'images/content/tab-current-bg.png', 'content');
	eLS.utils.ImagesPreload.add(serverSkinURL+'images/content/tabs-beetween.png', 'content');
	eLS.utils.ImagesPreload.add(serverSkinURL+'images/content/tabs-bg.png', 'content');
	eLS.utils.ImagesPreload.add(serverSkinURL+'images/toolbar/switch-mode/lms.png', 'toolbar');
	eLS.utils.ImagesPreload.add(serverSkinURL+'images/toolbar/switch-mode/cms.png', 'toolbar');
	eLS.utils.ImagesPreload.add(serverSkinURL+'images/toolbar/switch-mode/at.png', 'toolbar');
	eLS.utils.ImagesPreload.add(serverSkinURL+'images/toolbar/switch-mode/sis.png', 'toolbar');
	eLS.utils.ImagesPreload.add(serverSkinURL+'images/tooltip/failed.gif', 'tooltip');
	eLS.utils.ImagesPreload.add(serverSkinURL+'images/tooltip/ajax-loader.gif', 'tooltip');
	eLS.utils.ImagesPreload.add(serverSkinURL+'images/tooltip/stem.gif', 'tooltip');
	WindowEvent.observe('resize', function(event) {
		event = event || {};
		var thread = !!event.thread;
		var domNodes = eLS.cache.domNodes;
		var ac = arguments.callee;
		if (!thread) {
			if (!!ac.timeout) { clearTimeout(ac.timeout); }
			ac.timeout = setTimeout(function() {
				WindowEvent.fire('resize', {thread: true});
			}, 300);
			return;
		}
		if (currentVisibleTooltip) {
			positionTooltip(currentVisibleTooltip);
		}
		if (!domNodes.leftPanel || !domNodes.centerPanel || !domNodes.rightPanel) {
			domNodes.leftPanel   = $P('left-panel');   //   NULL
			domNodes.centerPanel = $P('center-panel'); //   NULL
			domNodes.rightPanel  = $P('right-panel');  //   NULL
		}
		if (!domNodes.autoSizeFit) {
			domNodes.autoSizeFit = $A(document.getElementsByClassName('auto-size-fit'))
				.map(function(el) { return $P(el); });
		}
		var centerPanelPaddingLeft  = domNodes.centerPanel ? (parseInt(domNodes.centerPanel.getStyle('padding-left'),  10) || 0) : 0;
		var centerPanelPaddingRight = domNodes.centerPanel ? (parseInt(domNodes.centerPanel.getStyle('padding-right'), 10) || 0) : 0;
		var paddings = $('#center-panel-wrapper').outerWidth(true) - $('#center-panel-wrapper').innerWidth();
		var menuVisiblePart = (domNodes.leftPanel ? domNodes.leftPanel.getWidth() : 0) - document.viewport.getScrollOffsets().left;
		menuVisiblePart = menuVisiblePart >= 0 ? menuVisiblePart : 0;
		var newWidth = document.viewport.getDimensions().width - menuVisiblePart - paddings;
		// TODO:  
		newWidth = (newWidth < 300) ? 300 : newWidth;
		if (self.Effect) {
			Effect.Queues.get('.auto-size-fit').each(function(e) { e.cancel(); });
		}
		$A(domNodes.autoSizeFit).each(function(item) {
			var p = $P(item).up('.els-content');
			var w = newWidth;
			if (p) {
				w -= 20;
			}
			if (self.Effect) {
				$P(item).morph({width: ''+ w +'px'}, {
					duration: 0.3,
					queue: {scope: '.auto-size-fit'},
					afterFinish: function(effect) {
						if (!effect.element.style.width) { effect.element.setStyle({'width':''+ w +'px'}); }
					}
				});
			} else {
				$P(item).setStyle({width: ''+ w +'px'});
			}
			
		});
//			domNodes.autoSizeFit.invoke('morph', {width: ''+ newWidth +'px'}, {
//				duration: 0.3,
//				queue: {scope: '.auto-size-fit'},
//				afterFinish: function(effect) {
//					if (!effect.element.style.width) { effect.element.setStyle({'width':''+ newWidth +'px'}); }
//				}
//			});
//		} else {
//			domNodes.autoSizeFit.invoke('setStyle', {width: ''+ newWidth +'px'});
//		}
		/**/
		var cpw = $('#center-panel-wrapper');
		if (cpw.length && cpw.get(0).firstChild && cpw.get(0).firstChild.nodeType == 1) {
			var bordersAndMargins = cpw.outerHeight(true) - cpw.innerHeight(); //  
			var offset = cpw.offset().top;
			var contentHeight = $(cpw.get(0).firstChild).innerHeight();
			var vpHeight = $(window).height();
			var newHeight = vpHeight - offset - bordersAndMargins;
			
			if (newHeight > contentHeight) {
				if (self.Effect) {
					Effect.Queues.get('.auto-height-fit').each(function(e) { e.cancel(); });
					[$P(cpw.get(0))].invoke('morph', {height: ''+ newHeight +'px'}, {
						duration: 0.3,
						queue: {scope: '.auto-height-fit'},
						afterFinish: function(effect) {
							WindowEvent.fire('resize');
							if (!effect.element.style.height) { effect.element.setStyle({'height':''+ newHeight +'px'}); }
						}
					});
				} else {
					cpw.height(newHeight);
				}
			} else {
				cpw.css('height', 'auto');
			}
		}
	});
	WindowEvent.observe('scroll', function(event) {
		event = event || {};
		var thread = !!event.thread;
		var domNodes = eLS.cache.domNodes;
		var ac = arguments.callee;
		if (!thread) {
			if (!!ac.timeout) { clearTimeout(ac.timeout); }
			ac.timeout = setTimeout(function() {
				WindowEvent.fire('scroll', {thread: true});
			}, 300);
			return;
		}
		if (!domNodes.leftPanel || !domNodes.centerPanel || !domNodes.rightPanel) {
			domNodes.leftPanel   = $P('left-panel');   //   NULL
			domNodes.centerPanel = $P('center-panel'); //   NULL
			domNodes.rightPanel  = $P('right-panel');  //   NULL
		}
		if (!domNodes.autoHorizontalScroll) {
			domNodes.autoHorizontalScroll = $A(document.getElementsByClassName('auto-hscroll'))
				.map(function(el) { return $P(el); });
		}
		var leftPanelWidth = !!domNodes.leftPanel ? domNodes.leftPanel.getWidth() : 0;
		var viewportScrollOffsets = document.viewport.getScrollOffsets();
		var diff = 0;
		if (viewportScrollOffsets.left > leftPanelWidth) {
			diff = viewportScrollOffsets.left - leftPanelWidth;
		}
		if (self.Effect) {
			Effect.Queues.get('.auto-hscroll').each(function(e) { e.cancel(); });
			domNodes.autoHorizontalScroll
				.invoke('morph', {'marginLeft': ''+ diff +'px'}, {queue: {scope: '.auto-hscroll'}, duration: 0.3});
		} else {
			domNodes.autoHorizontalScroll
				.invoke('setStyle', {'marginLeft': ''+ diff +'px'});
		}
		WindowEvent.fire('resize');
	});

	/* BEGIN: Tooltips */
	//  
	var tooltipTemplate = new Template(
		['<div class="tooltip" id="#{tooltip-id}" url="#{tooltip-url}" style="display: block; top: -1000px; left: -1000px;" link-id="#{link-id}">',
			'<div class="orientation"><div class="wrapper">',
				'<div class="stem"></div>',
				'<div class="body">',
					'<div class="wrapper #{loader}">',
						'#{content}',
					'</div>',
				'</div>',
			'</div></div>',
		'</div>'].join('')
	);

	var iFrameShimTooltipTemplate = new Template(
		'<iframe class="tooltip-iframe-shim" id="iframe-shim-#{tooltip-id}" style="display: none; top: -1000px; left: -1000px;" src="javascript:void(0);" frameborder="0" scrolling="no"></iframe>'
	);

	// ,      
	if (!$P('tooltip-stub')) {
		$P(document.body)
			.insert({bottom: 
				['<div class="tooltip-stub" id="tooltip-stub-root">',
					'<div id="tooltip-stub">',
						'<div id="tooltip-stub-wrapper"></div>',
					'</div>',
				'</div>'].join('')
			});
	}

	$P(document).observe('tabs:modified', function(event) {
		hideTooltip();
		WindowEvent.fire('resize');
	});

	//  ,     
	var tooltips = document.getElementsByClassName('tooltip');
	for (var i = 0; i < tooltips.length; ++i) {
		currentVisibleTooltip = tooltips[i];
		hideTooltip();
	}
	
	//       , 
	//     
	var tooltipLinks = document.getElementsByClassName('tooltip-link');
	var link;
	for (var i = 0; i < tooltipLinks.length; ++i) {
		link = tooltipLinks[i];
		if ((link.readAttribute('tooltip-activate-by') || '').strip() != 'mouseover') {
			continue;
		}
		link
			.observe('mouseover', function(event) {
				hideTooltip();
				showTooltip($P(this), event);
			})
			.observe('mouseout', hideTooltip);
	}

	var currentVisibleTooltip, currentVisibleTooltipLink;

	function positionTooltip(Tooltip, pointer) {
		if (!Tooltip) { return; }
		link = $P(Tooltip.readAttribute('link-id'));
		if (!link) { return; }
		var linkOffsets = link.cumulativeOffset(),
				viewportScrollOffsets = document.viewport.getScrollOffsets(),
				viewportDimensions = document.viewport.getDimensions(),
				linkDimensions = link.getDimensions();
				
		// fix viewportOffsets in IE
		var viewportOffsets = {};
		viewportOffsets.top = linkOffsets.top - viewportScrollOffsets.top;
		viewportOffsets.left = linkOffsets.left - viewportScrollOffsets.left;

		var tooltipDimenstions = Tooltip.getDimensions();
		
		//  ,    !!!
		var position = ((tooltipDimenstions.height > viewportOffsets.top) ? 'top' : 'bottom')
			+ '-'
			+ ((tooltipDimenstions.width > viewportDimensions.width - viewportOffsets.left) ? 'right' : 'left');
		Tooltip.down('.orientation')
			.removeClassName('top-left')
			.removeClassName('top-right')
			.removeClassName('bottom-left')
			.removeClassName('bottom-right')
			.addClassName(position);
		var ttPosition;
		var add = (link.getStyle('display') == 'block' || link.match('img')) ? linkDimensions.width / 2 : 5;
		switch (position) {
		case 'top-left':
			ttPosition = {
				top: viewportScrollOffsets.top + viewportOffsets.top + linkDimensions.height,
				left: pointer ? pointer.x : viewportScrollOffsets.left + viewportOffsets.left + add
			};
			break;
		case 'top-right':
			ttPosition = {
				top: viewportScrollOffsets.top + viewportOffsets.top + linkDimensions.height,
				left: pointer ? pointer.x - tooltipDimenstions.width : viewportScrollOffsets.left + viewportOffsets.left - tooltipDimenstions.width + add
			};
			break;
		case 'bottom-left':
			ttPosition = {
				top: viewportScrollOffsets.top + viewportOffsets.top - tooltipDimenstions.height,
				left: pointer ? pointer.x : viewportScrollOffsets.left + viewportOffsets.left + add
			};
			break;
		case 'bottom-right':
		default:
			ttPosition = {
				top: viewportScrollOffsets.top + viewportOffsets.top - tooltipDimenstions.height,
				left: pointer ? pointer.x - tooltipDimenstions.width : viewportScrollOffsets.left + viewportOffsets.left - tooltipDimenstions.width + add
			};
			break;
		}

		Tooltip.setStyle({
			top: '' + ttPosition.top + 'px',
			left: '' + ttPosition.left + 'px'
		});
		$P('iframe-shim-'+ Tooltip.id).setStyle({
			width: '' + tooltipDimenstions.width + 'px',
			height: '' + tooltipDimenstions.height + 'px',
			top: '' + ttPosition.top + 'px',
			left: '' + ttPosition.left + 'px',
			display: 'block'
		});
	}
	function resizeTooltip(Tooltip) {
		if (!Tooltip) { return; }
		var wrapper = Tooltip.down('.wrapper', 1),
				dimensions = {}, ttStub,
				ac = arguments.callee,
				dims = {};
		if (!wrapper) { return; }
		if (!ac.tts || !ac.ttsw || !ac.ttsr) {
			ac.tts  = $P('tooltip-stub');
			ac.ttsw = $P('tooltip-stub-wrapper');
			ac.ttsr = $P('tooltip-stub-root');
		}
		if (!ac.tts || !ac.ttsw || !ac.ttsr) { return; }
		if (wrapper.hasClassName('loader') || wrapper.hasClassName('failed')) {
			dimensions = {
				width: 24,
				height: 24
			};
		} else {
			ac.ttsw.innerHTML = wrapper.innerHTML;

			dims = ac.tts.getDimensions();

			//  2 , ..  wrapper'
			//    padding's
			// - margin'  ""
			dimensions.height = dims.height - 2;
			ac.ttsr.addClassName('no-overflow');
			dimensions.width = ac.tts.getWidth();
			ac.ttsr.removeClassName('no-overflow');

			ac.ttsw.innerHTML = '';
		}
		if (dimensions.width > 300) {
			dimensions.width = 300;
		} else if (dimensions.width < 24) {
			dimensions.width = 24;
		}
		if (dimensions.height > 200) {
			dimensions.height = 200;
		} else if (dimensions.height < 24) {
			dimensions.height = 24;
		}
		Tooltip.down('.body').setStyle({
			width: ''+ dimensions.width +'px',
			height: ''+ dimensions.height +'px',
			'overflow': (dims.width == dimensions.width) ? 'hidden' : 'auto'
		});
	}
	function getTooltipElement(element) {
		var tooltipId,
				tooltipLinkId,
				tooltipUrl,
				tooltipContentId,
				tooltipContent,
				tooltipElement;
		tooltipId = element.readAttribute('tooltip-id') || '';
		tooltipLinkId = element.identify();
		if (tooltipId) {
			tooltipElement = $P(tooltipId);
			if (!tooltipElement || !tooltipElement.hasClassName('tooltip')) {
				tooltipId = '';
				tooltipElement = null;
			} else {
				tooltipElement.writeAttribute('link-id', tooltipLinkId);
				return tooltipElement;
			}
		}
		tooltipContentId = element.readAttribute('tooltip-content-id');
		if (tooltipContentId) {
			tooltipContent = $P(tooltipContentId);
			if (tooltipContent) {
				tooltipContent = (tooltipContent.innerHTML || '').stripScripts();
			}
		}
		tooltipUrl = element.readAttribute('tooltip-url');
		tooltipElement = (new Element('div')).update(tooltipTemplate.evaluate({
			'tooltip-id': tooltipId,
			'tooltip-url': tooltipUrl,
			'content': tooltipContent,
			'loader': tooltipContent ? '' : (tooltipUrl ? 'loader' : 'failed'),
			'link-id': tooltipLinkId
		})).down();
		tooltipId = tooltipElement.identify();
		iFrameShimTooltipElement = (new Element('div')).update(
			iFrameShimTooltipTemplate.evaluate({
				'tooltip-id': tooltipId
			})
		).down();
		element.writeAttribute('tooltip-id', tooltipId);
		$P(document.body).insert({bottom: tooltipElement});
		$P(document.body).insert({bottom: iFrameShimTooltipElement});
		return tooltipElement;
	}
	function hideTooltip() {
		if (currentVisibleTooltip) {
			$P('iframe-shim-'+ currentVisibleTooltip.id).setStyle({
				top: '-1000px',
				left: '-1000px',
				display: 'none'
			});
			currentVisibleTooltip.setStyle({
				top: '-1000px',
				left: '-1000px'
			});
			$P('iframe-shim-'+ currentVisibleTooltip.id).setStyle({
				top: '-1000px',
				left: '-1000px',
				display: 'none'
			});
			currentVisibleTooltip = null;
			currentVisibleTooltipLink = null;
		}
	}
	function showTooltip(link, event) {
		var tooltipElement = getTooltipElement(link);
		resizeTooltip(tooltipElement);
		if (currentVisibleTooltipLink == link) {
			hideTooltip();
			return;
		} else if (currentVisibleTooltip != tooltipElement) {
			hideTooltip();
		}
		var tooltipUrl = tooltipElement.readAttribute('url');
		currentVisibleTooltip = tooltipElement;
		currentVisibleTooltipLink = link;
		var pointer = event.pointer();
		positionTooltip(tooltipElement, pointer);
		if (tooltipUrl && !tooltipElement.ajaxActive) {
			tooltipElement.ajaxActive = true;
			function failedRequest(request) {
				tooltipElement.ajaxActive = false;
				tooltipElement
					.down('.wrapper', 1)
					.removeClassName('loader')
					.addClassName('failed')
					.update('');
				resizeTooltip(tooltipElement);
			}
			new Ajax.Request(tooltipUrl, {
				method: 'get',
				onCreate: function(request) {
					tooltipElement
						.down('.wrapper', 1)
						.removeClassName('failed')
						.addClassName('loader')
						.update('');
					resizeTooltip(tooltipElement);
				},
				onSuccess: function(request) {
					tooltipElement.ajaxActive = false;
					if (!request.responseText) { throw 'responseText is empty'; }
					tooltipElement.writeAttribute('url', null);
					tooltipElement
						.down('.wrapper', 1)
						.removeClassName('loader')
						.removeClassName('failed')
						.update(request.responseText.stripScripts());
					resizeTooltip(tooltipElement);
					positionTooltip(tooltipElement, pointer);
				},
				onException: failedRequest,
				onFailure: failedRequest
			});
		}
	}

	$P(document.body).observe('click', function(event) {
		var element = event.element();
		//  ,   5- 
		//   
		for (var i = 0; i < 5; ++i) {
			if (!element || element.nodeType != 1) { break; }
			if (element.match('.tooltip-link')) {
				if (element.match('a')) { event.stop(); }
				break;
			}
			element = element.up();
		}
		if (!element || element.nodeType != 1 || !element.match('.tooltip-link') || (element.readAttribute('tooltip-activate-by') || 'click') != 'click') {
			if (currentVisibleTooltip && !event.element().descendantOf(currentVisibleTooltip)) {
				hideTooltip();
			}
			return;
		}
		showTooltip(element, event);
	});
	/* END: Tooltips */

	function isEnterKey(event) {
		return event.keyCode == 13;
	}
	function isSpaceKey(event) {
		return event.keyCode == 32 || event.charCode == 32;
	}
	function isEnterOrSpace(event) {
		return isEnterKey(event) || isSpaceKey(event);
	}

	/**
	 *   
	 */
	var tabsWithId = $A(document.getElementsByClassName('tabs-controller'))
		.findAll(function(el) {
			return !!el.id
		});
	tabsWithId.each(function(item) {
		var _$ = $P(item); // controller
		var controllerTabs = _$.down('.tab');
		if (!controllerTabs) { return; }
		//     
		controllerTabs = controllerTabs
			.up()
			.childElements()
			.findAll(function(el) {
				return el.hasClassName('tab');
			});
		var currentTab = null;
		var currentTabIndex = -1;
		currentTab = controllerTabs.find(function(el) {
			return el.hasClassName('current');
		});
		//   ( ),   
		// TODO:      (Cookie  top.name)
		var storedTabId = top.name;
		if (!currentTab && storedTabId) {
			//     id  , ..    
			// -
			currentTab = controllerTabs.find(function(el) {
				return (el.down('a').readAttribute('href') || ' ') == '#' + storedTabId;
			});
		}
		if (currentTab) {
			currentTabIndex = controllerTabs.indexOf(currentTab);
			//    ,  -
			//    
			for (var i = currentTabIndex + 1; i < controllerTabs.length; ++i) {
				controllerTabs[i].removeClassName('current');
			}
		} else if (_$.hasClassName('show-first')) {
			currentTab = controllerTabs.find(function(el) {
				return !el.hasClassName('has-href');
			});
			currentTabIndex = controllerTabs.indexOf(currentTab);
		}
		if (currentTab) {
			currentTab.addClassName('current');
			if ((currentTab.readAttribute('href') || ' ').strip().match(/^#tab/)) {
				top.name = currentTab.readAttribute('href').strip().match(/^#tab.*/)[0].slice(1);
			}
			Element.fire.defer(_$, 'tabs:modified');
			Element.fire.defer(_$, 'tabs:changed');
		}
		//        
		var Slaves = (_$.readAttribute('control-for') || ' ')
			.strip()
			.split(/\s+/)
			.without('')
			.map(function(id) {
				return $P(id); 
			});
		if (Slaves.length == 0) {
			//   
			var tabsContainer = _$.up('.tabs');
			var tabsContent = tabsContainer
				? tabsContainer.down('.tabs-content')
				: null;
			if (tabsContent) { Slaves.push(tabsContent); }
		}
		Slaves = Slaves.without(null);
		if (Slaves.length == 0) { return; }
		if (!eLS.TabsData) { eLS.TabsData = {}; }
		if (!eLS.TabsData[_$.id]) {
			eLS.TabsData[_$.id] = {
				node: _$,             // 
				tabs: controllerTabs, //   
				toggled: true,        // -  :)
				slaves: []            //  
			};
		}
		for (var i = 0; i < Slaves.length; ++i) {
			var slave = Slaves[i];
			var slaveTabs = slave.down('.tab');
			if (!slaveTabs) { continue; }
			slaveTabs = slaveTabs
				.up()
				.childElements()
				.findAll(function(el) {
					return el.hasClassName('tab');
				})
				.invoke('removeClassName', 'current');
			eLS.TabsData[_$.id].slaves.push({
				node: slave,
				tabs: slaveTabs
			});
			eLS.TabsData[_$.id].toggled = eLS.TabsData[_$.id].toggled
				&& slave.hasClassName('toggled');
			if (!currentTab || !slaveTabs[currentTabIndex]) {
				slave.hide();
			} else if (slaveTabs[currentTabIndex]) {
				slaveTabs[currentTabIndex].addClassName('current');
				slave.show();
			}
		}
		//       onclick
		function tabActivate(event) {
			var $this = $P(this); // controller
			var target = $P(event.element());
			if (!target.hasClassName('tab')) {
				target = target.up('.tab');
			}
			if (!target) { return true; }
			var targetA = target.down('a');
			//   A  ,    
			if (targetA && !(targetA.readAttribute('href') || 'javascript').strip().match(/^(#tab|javascript)/)) {
				return true;
			}
			event.stop();
			if (self.Effect && Effect.Queues.get($this.id).effects.length > 0) { return false; }
			if ((targetA.readAttribute('href') || ' ').strip().match(/^#tab/)) {
				// TODO: DataStorage
				top.name = targetA.readAttribute('href').strip().match(/^#tab.*/)[0].slice(1);
			}
			// 
			var controllerTabs = eLS.TabsData[$this.id].tabs;
			var Slaves = eLS.TabsData[$this.id].slaves;
			var slave = null;
			var slaveTabs = null;
			// TODO: scroll-to-zero (   )
			if (!target.hasClassName('current')) {
				var index = controllerTabs
					.invoke('removeClassName', 'current')
					.indexOf(target);
				controllerTabs[index]
					.addClassName('current');
				Element.fire.defer($this, 'tabs:changed');
				for (var i = 0; i < Slaves.length; ++i) {
					slave = Slaves[i].node;
					slaveTabs = Slaves[i].tabs;
					slaveTabs.invoke('removeClassName', 'current');
					if (!slaveTabs[index]) {
						slave.hide();
						continue;
					}
					slaveTabs[index].addClassName('current');
					Element.fire.defer($this, 'tabs:modified');
					if (self.Effect && !slave.visible()) {
						new Effect.toggle(slave, 'blind', {
							queue: { scope: $this.id },
							afterFinish: function(effect) {
								Element.fire.defer($this, 'tabs:modified');
							},
							duration: 0.3
						});
					} else if (!slave.visible()) {
						slave.show();
						Element.fire.defer($this, 'tabs:modified');
					}
				}
			} else {
				for (var i = 0; i < Slaves.length; ++i) {
					slave = Slaves[i].node;
					slaveTabs = Slaves[i].tabs;
					if (!slave.hasClassName('toggled')) { continue; }
					if (self.Effect) {
						new Effect.toggle(slave, 'blind', {
							afterFinish: function(effect) {
								if (eLS.TabsData[$this.id].toggled) {
									controllerTabs
										.invoke('removeClassName', 'current');
									Element.fire.defer($this, 'tabs:changed');
								}
								Element.fire.defer($this, 'tabs:modified');
							},
							queue: { scope: $this.id },
							duration: 0.3
						});
					} else {
						slave.hide();
						if (eLS.TabsData[$this.id].toggled) {
							controllerTabs
								.invoke('removeClassName', 'current');
							Element.fire.defer($this, 'tabs:changed');
						}
						Element.fire.defer($this, 'tabs:modified');
					}
				}
			}
		}
		_$.observe('keypress', function(event) {
			if (!isEnterKey(event)) { return; }
			tabActivate.call(this, event);
		});
		_$.observe('click', tabActivate);
	});
	
	var orgFilter = $P('org-filter');
	if (orgFilter) {
		orgFilter.observe('click', function(event) {
			if (self.Effect && Effect.Queues.get('.org-filter').effects.length > 0) { return; }
			var target = $P(event.element());
			if (!target.hasClassName('tb-actions')) { return; }
			var element = target.up('div.wrapper').down('.user-actions');
			if (!element) { return; }
			if (self.Effect) {
				new Effect.toggle(element, 'blind', {
					afterFinish: function (effect) {
						WindowEvent.fire('resize');
					},
					duration: 0.3,
					queue: {scope: '.org-filter'}
				});
			} else {
				element.visible() ? element.hide() : element.show();
				WindowEvent.fire('resize');
			}
		});
	}	
	var userMenu = $P('user-menu');
	if (userMenu) {
		var onClickUserMenu = function(event) {
			if (self.Effect && Effect.Queues.get('.user-menu').effects.length > 0) { return; }
			var target = $P(event.element());
			if (!target || !target.match('.tb-actions')) { return; }
			var element = target.up('div.wrapper').down('.user-actions');
			if (!element) { return; }
			event.stop();
			if (self.Effect) {
				new Effect.toggle(element, 'blind', {
					afterFinish: function (effect) {
						var target = effect.element.up().down('.tb-actions');
						if (effect.element.visible()) {
							target
								.removeClassName('tb-actions-open')
								.addClassName('tb-actions-close');
						} else {
							target
								.removeClassName('tb-actions-close')
								.addClassName('tb-actions-open');
						}
						WindowEvent.fire('resize');
					},
					duration: 0.3,
					queue: {scope: '.user-menu'}
				});
			} else {
				element.visible() ? (function() {element.hide(); target.removeClassName('tb-actions-close').addClassName('tb-actions-open');})() : (function() { element.show(); target.removeClassName('tb-actions-open').addClassName('tb-actions-close'); })();
				WindowEvent.fire('resize');
			}
		}
		userMenu
			.observe('click', onClickUserMenu)
			.observe('keypress', function(event) {
				if (!isEnterKey(event)) { return; }
				onClickUserMenu(event);
			});
	}
	var menu = $P('menu');
	if (menu) {
		var expandMenuItem = function(event) {
			if (!Prototype.Browser.IE && Effect && Effect.Queues.get('.menu').effects.length > 0) { return; }
			var target = $P(event.element());
			if (target.match('.span') && !target.down('a') && !target.up('.current')) {
				var element = target.up('.eLS-panel-content-block').select('div > ul:not(:empty)').pop();
				if (!element) { return; }
				element = element.up();
				event.stop();
				if (self.Effect && !Prototype.Browser.IE) {
					new Effect.toggle(element, 'appear', {
						afterFinish: function (effect) {
							WindowEvent.fire('resize');
						},
						duration: 0.3,
						queue: {scope: '.menu'}
					});
				} else {
					element.visible() ? element.hide() : element.show();
					WindowEvent.fire('resize');
				}
			}
		}
		menu
			.observe('click', expandMenuItem)
			.observe('keypress', function(event) {
				if (!isEnterKey(event)) { return; }
				//var target = event.element();
				//if (event.keyCode == 0 && event.charCode == 32) {
				//	event.stop();
				//}
				//if (target.match('a') && target.click) {
				//	target.click();
				//	event.stop();
				//	return;
				//}
				expandMenuItem(event);
			});
	}

	/*    */
	
	function extractSubtree(root, element) {
		if (Object.isString(element)) {
			element = $P(element);
		}
		if (!element || !root) { return; }
		var clonedElement = element.cloneNode(true);
		var rootUl = root.down('ul');
		if (!rootUl) { return; }
		rootUl.update('');
		rootUl.insert(clonedElement);
	}
	
	function treeViewHelper(val) {
		val = jQuery(val);
		jQuery('li > ul', val).each(function() {
			var ul = jQuery(this);
			var li = ul.parent();
			if (li.get(0).className.indexOf('branch') == -1) {
				li.addClass('branch');
			}
			if (li.hasClass('branch-expanded') && !ul.children('li').length) {
				li.swapClass('branch', 'branch-expanded');
			}
		});
		jQuery('ul > li:last-child', val)
			.addClass('bottom');
		//   , .. Ajax     
		//      ,   ,
		//       treeViewHelper
		jQuery('li.branch, li.branch-expanded', val).each(function() {
			var li = jQuery(this)
				.prepend('<div class="hitarea"></div>');
				if (li.hasClass('branch-expanded') && !li.children('ul').length) {
					li.swapClass('branch', 'branch-expanded');
					requestTreeFromServer($P(li.get(0)));
				}
		});
	}
	var treeViews = $A(document.getElementsByClassName('tree-view'))
		.map(function(el) { return $P(el); });
	if (treeViews.length > 0) {
		['vertical-pixel',
		 'branch-collapsed',
		 'leaf',
		 'add',
		 'edit',
		 'delete',
		 'branch-expanded',
		 'root-branch-collapsed',
		 'root-leaf',
		 'root-branch-expanded',
		 'clox'].each(function(file) {
				eLS.utils.ImagesPreload.add(serverSkinURL+'images/tree-view/'+file+'.gif', 'tree-view');
		 });
	}
	if (treeViews.find(function(el) { return el.hasClassName('org-structure'); })) {
		['position-default',
		 'root-position-default',
		 'position-boss',
		 'root-position-boss'].each(function(file) {
				eLS.utils.ImagesPreload.add(serverSkinURL+'images/tree-view/org-structure/'+file+'.gif', 'org-structure');
		 });
	}

	var titleEditElement = null;
	// TODO: title edit
	function titleEdit(text) {
		titleEditElement = titleEditElement || new Element('span', {'class':'title-edit'}).update([
			'<input class="text-value" type="text" />',
			'<span class="original-text-value" style="display: none;"></span>',
			'<input type="button" value="" class="apply-edit-button" /><input type="button" value="" class="cancel-edit-button" />'
		].join(''));
		var textValue = titleEditElement.down('.text-value');
		textValue.value = text;
		textValue.size = Math.min(text.length + 5, 60);
		titleEditElement.down('.original-text-value').update(text);
		return titleEditElement;
	}
	function fireEditOnElement(li) {
		var liText = getNodeText(li).strip();
		var buttons = li.down('.element-buttons');
		var elements2remove = [], child;
		for (var i = 0; i < li.childNodes.length; ++i) {
			child = li.childNodes[i];
			if (child.nodeType == 3 || (child.nodeType == 1 && child.nodeName.toLowerCase() == 'a')) {
				elements2remove.push(child);
			}
		}
		for (var i = 0; i < elements2remove.length; ++i) {
			$P(elements2remove[i]).discard();
		}
		buttons
			.insert({before : titleEdit(liText)})
			.hide();
	}
	function cancelEditingElement(li, updateTextFromInput) {
		if (li && li.match('li') && li.down('.title-edit')) {
			var liText = (updateTextFromInput) ? li.down('.text-value').value : getNodeText(li.down('span.original-text-value'));
			if (liText.strip() == '') {
				liText = getNodeText(li.down('span.original-text-value'));
			}
			li.insertBefore(document.createTextNode(liText), titleEditElement);
			titleEditElement.select('input').each(function(e) { e.blur(); });
			li.removeChild(titleEditElement);
			var buttons = li.down('.element-buttons');
			if (buttons) {
				buttons.show();
			}
			if (updateTextFromInput) {
				li.addFlag('title-changed');
			}
		}
	}
	function requestTreeFromServer(li, callback) {
		var url = getRequestUrl(li);
		if (!url) { return; }
		li.down('.hitarea').addClassName('clox');
		new Ajax.Request(url, {
			method: 'get',
			parameters: $H({id: li.readAttribute('id')}),
			onLoading: function() {  },
			onSuccess: function(transport) {
				// !  ul    ,
				//     ul.
				//   li  
				if (!li.down('ul')) {
					var resp = transport.responseText || '';
					if (resp == '') { resp = '<ul></ul>'; }
					li.insert(resp);
					treeViewHelper(li);
					var newUL = li.down('ul');
					if (newUL && newUL.down('li')) {
						li.swapClassName('branch', 'branch-expanded');
					}
					li.down('.hitarea')
						.removeClassName('clox');
					if (callback) { callback(); }
				}
			},
			onException: function() {
				eLS.utils.showMessageBox('', '   !');
			},
			onError: function() {
				eLS.utils.showMessageBox('', '   !');
			}
		});
	}
	function toggleElement(el, callback) { // el must be div.hitarea
		if (!el) { return; }
		var li = el.match('li') ? el : el.up('li');
		if ( el.match('div.hitarea')
				&& li.className.indexOf('branch') != -1) {
			var ul = li.down('ul');
      
			// IE fix
			if (el.hasClassName('clox')) {
				if (ul) {
					el.removeClassName('clox');
				} else {
					return;
				}
			}
			if (ul && ul.down('li')) {
				li.swapClassName('branch', 'branch-expanded');
				var url = getRequestUrl(li);
				if (url) {
					new Ajax.Request(url, {
						method: 'get',
						parameters: $H({id: li.readAttribute('id'), action: li.hasClassName('branch-expanded') ? 'expand' : 'collapse'})
					});
				}
				if (callback) { callback(); }
			} else if (!ul) {
				requestTreeFromServer(li, callback);
			} else if (callback) {
				//    ,    <ul>
				//   ,    drag'n'drop
				li.swapClassName('branch', 'branch-expanded');
				callback();
			}
		}
	}
	function markDropTargetForInsideAddition() {
		if (!self.dragEvent || !self.dragEvent.dropTarget) { return; }
		var li = self.dragEvent.dropTarget;
		if (!li.match('li')) { li = li.up('li'); }
		if (!li || li.className.indexOf('branch') == -1) { return; }
		li.addClassName('add-inside');
	}
	function unmarkDropTargetForInsideAddition() {
		if (!self.dragEvent || !self.dragEvent.dropTarget) { return; }
		clearTimeout(self.dragEvent.insideAdditionTimer);
		var li = self.dragEvent.dropTarget;
		if (!li.match('li')) { li = li.up('li'); }
		if (li) { li.removeClassName('add-inside'); }
	}
	function addNewElement(li, newTitle, after) {
		if (!li || !li.match('li')) { return; }
		var liIsLast = !li.next('li');
		if (liIsLast) { li.removeClassName('bottom'); }
		var newElement = new Element('li', {
			'class': 'branch'+ (liIsLast ? ' bottom' : '')
		}).update('<div class="hitarea"></div>'+ newTitle +'<ul></ul>');
		li.insert(after ? { after: newElement } : { before: newElement });
		var parent = li.up('li');
		if (parent) {
			parent.addFlag('changed-inside');
		}
	}
	function addElement(Target, Source, after) {
		Target.insert( after ? { after: Source } : { before: Source } );
		if (Target.next('li')) {
			Target.removeClassName('bottom');
		} else {
			Target.addClassName('bottom');
		}
		if (Source.next('li')) {
			Source.removeClassName('bottom');
		} else {
			Source.addClassName('bottom');
		}
	}
	function addElementInto(Target, Source) {
		if (!Target || !Target.match('li')) { return; }
		function doAddition() {
			var ul = Target.down('ul');
			//         
			// ..   onError  Ajax 
			if (!ul) { return; }
			var liBottom = ul.down('li.bottom');
			if (liBottom) {
				liBottom.removeClassName('bottom');
			}
			Source.addClassName('bottom');
			ul.insert({ bottom: Source });
			Target.addFlag('changed-inside');
		}
		if (Target.hasClassName('branch')) {
			toggleElement(Target.down('.hitarea'), doAddition);
		} else if (Target.hasClassName('branch-expanded')) {
			doAddition();
		} else {
			// ERROR,    
		}
	}

	var previouslySelectedElement = null;
	var elementButtons = null;
	function selectElement(element, hasToBeSelected) {
		if (!element) { return; }
		if (!element.match('li')) { return; }
		var isEditable = element.up('.tree-view').hasClassName('editable');
		if (!isEditable) { return; }
		var isSelected = element.hasClassName('selected');
		if (hasToBeSelected) {
			if (isSelected) { return; }
			if (previouslySelectedElement != element) {
				selectElement(previouslySelectedElement, false);
			}
			if (isEditable) {
				var numChildren = element.childNodes.length;
				var node = null;
				for (var i = 0; i < numChildren; i++) {
					node = element.childNodes[i];
					if (node.nodeType == 3 || (node.nodeType == 1 && node.nodeName.toLowerCase() == 'a')) {
						do {
							node = node.nextSibling;
						} while (node && (node.nodeType == 3 || (node.nodeType == 1 && node.nodeName.toLowerCase() == 'a')));
						element.insertBefore(elementButtons, node);
						break;
					}
				}
			}
			element.addClassName('selected');
			previouslySelectedElement = element;
		} else {
			if (!isSelected) { return; }
			cancelEditingElement(element);
			if (isEditable) {
				element.removeChild(elementButtons);
			}
			element.removeClassName('selected');
		}
	}
	var pageContainsDraggables = false;
	var pageContainsEditables = false;

	treeViews
		.each(function(val) {
			if (f_isFrameAccessible(window.parent)) {
				if (window.parent.eLSChildOptions && window.parent.eLSChildOptions.treeview) {
					if (window.parent.eLSChildOptions.treeview.extractSubtree) {
						extractSubtree(val, window.parent.eLSChildOptions.treeview.extractSubtree);
					}
				}
			}
			treeViewHelper(val);
			val = $P(val);
			var isDraggable = val.hasClassName('draggable');
			var isDropable  = val.hasClassName('dropable');
			var isEditable  = val.hasClassName('editable');
			var copyOnly    = val.hasClassName('copy-only');
			if (isDraggable) {
				pageContainsDraggables = true;
				val.observe('mousedown', function(event) {
					var el = $P(event.element());
					if (el.match('a')) { event.stop(); }
					if (self.dragEvent) {
						stopDrag(event);
						return;
					}
					if (el.match('.hitarea')) { return; }
					if (!el.match('li')) {
						el = el.up('li');
					}
					if (!el || !el.match('li')) { return; }
					if (el != previouslySelectedElement) {
						selectElement(previouslySelectedElement, false);
					}
					if (!isEditable) {
						el.addClassName('selected-to-drag');
						$P(document.body).addClassName('something-is-dragged');
					}
					self.dragEvent = {
						dragSource: el,
						keepDragSource: copyOnly,
						dropTarget: null
					};
					if (!event.element().match('input')) {
						event.stop();
					}
				});
			}
			if (isDropable) {
				val.observe('mousemove', function(event) {
					if (!self.dragEvent) { return; }
					var el = $P(event.element()), dt;
					if (!el.match('li')) {
						el = el.up('li');
					}
					if (!el) { return; }
					if ( (el == self.dragEvent.dragSource) ||
							(el.up(1).hasClassName("tree-view")) ||
							(el.descendantOf(self.dragEvent.dragSource)) ) {
						dt = self.dragEvent.dropTarget;
						if (dt) {
							dt
								.removeClassName("mouse-over-first-half")
								.removeClassName("mouse-over-second-half");
						}
						self.dragEvent.dropTarget = eLS.undefined;
						return;
					}
					if (!self.dragEvent.dragSource.hasClassName('selected-to-drag')) {
						self.dragEvent.dragSource.addClassName('selected-to-drag');
						$P(document.body).addClassName('something-is-dragged');
						selectElement(self.dragEvent.dragSource, false);
					}
					var elH = el.getHeight();
					var elY = el.cumulativeOffset().top;
					var curY = document.viewport.getScrollOffsets().top + event.clientY + ((Prototype.Browser.IE && el.hasClassName('branch'))?8:0); // IE hack
					var overFirstHalf = (curY-elY) < (elH / 2);
					dt = self.dragEvent.dropTarget;
					if (dt) {
						dt
							.removeClassName("mouse-over-first-half")
							.removeClassName("mouse-over-second-half");
					}
					self.dragEvent.dropTarget = el.addClassName(overFirstHalf ? "mouse-over-first-half":"mouse-over-second-half");
					unmarkDropTargetForInsideAddition()
					self.dragEvent.insideAdditionTimer = setTimeout(markDropTargetForInsideAddition, 1000);
					el = null;
				});
			}
			if (isDraggable || isDropable) {
				var cancelSelectEvent = function(event) {
					var el = $P(event.element());
					if (el.match('input')) { return; }
					event.stop();
				}
				var cancelEvent = function(event) { event.stop(); }
				val
					.observe('drag', cancelEvent)
					.observe('dragstart', cancelEvent)
					.observe('selectstart', cancelSelectEvent);
			}
			if (isEditable) {
				pageContainsEditables = true;
				val.writeAttribute('title', '  ');
				val
					.observe('keypress', function(event) {
						if (self.dragEvent) { return; }
						var code = event.wich || event.keyCode;
						var ret = (code == Event.KEY_RETURN);
						var esc = (code == Event.KEY_ESC);
						if (ret || esc) {
							var el = $P(event.element());
							if (el.match('input')) {
								cancelEditingElement(el.up('li'), ret);
							}
						}
					});
			}
		})
		.invoke('observe', 'click', function(event) {
			var el = $P(event.element());
			if (pageContainsEditables) {
				if (el.hasClassName('delete-button')) {
					var li = el.up('li');
					if (confirm('  "'+ getNodeText(li).strip() +'"?')) {
						if (li.hasClassName('bottom')) {
							var prev = li.previous('li');
							if (prev) {
								prev.addClassName('bottom');
							}
							if (!li.adjacent('li').length) {
								li.up('li').swapClassName('branch', 'branch-expanded');
							}
							prev = null;
						}
						li.up('li').addFlag('changed-inside');
						selectElement(previouslySelectedElement, false);
						if (previouslySelectedElement == li) {
							previouslySelectedElement = null;
						}
						li.discard();
					}
					li = el = null;
					return;
				} else if (el.hasClassName('add-button')) {
					addNewElement(el.up('li'), ' ', true);
					return;
				} else if (el.hasClassName('edit-button')) {
					fireEditOnElement(el.up('li'));
					return;
				} else if (el.hasClassName('apply-edit-button')) {
					cancelEditingElement(el.up('li'), true);
					return;
				} else if (el.hasClassName('cancel-edit-button')) {
					cancelEditingElement(el.up('li'));
					return;
				}
			}
			if ($P(this).hasClassName('editable') && el.match('a')) {
				event.stop();
			}
			if (el.match('span')) {
				el = el.up('li').down('div.hitarea');
			}
			toggleElement(el);
		});
	function stopDrag(event) {
		if (!self.dragEvent) { return; }
		var elSource = self.dragEvent.dragSource
			.removeClassName('selected-to-drag'),
		    elCopy = elSource,
		    elTarget = self.dragEvent.dropTarget;
		if (elTarget) {
			var addInside = elTarget.hasClassName('add-inside');
			unmarkDropTargetForInsideAddition();
			if (!self.dragEvent.keepDragSource) {
				elSource.up('li').addFlag('changed-inside');
			}
			elTarget.up('li').addFlag('changed-inside');
			var overFirstHalf = elTarget.hasClassName("mouse-over-first-half");
			elTarget
				.removeClassName("mouse-over-second-half")
				.removeClassName("mouse-over-first-half");
			var elSourcePrevious = elSource.previous('li');
			if (self.dragEvent.keepDragSource || elSource != elTarget) {
				var SourceUrl = getRequestUrl(elSource);
				var TargetUrl = getRequestUrl(addInside ? elTarget : $P(elTarget).up('li'));
				elCopy = (self.dragEvent.keepDragSource) ? elSource.cloneNode(true) : elSource.up().removeChild(elSource);
				if (self.dragEvent.keepDragSource) {
					elCopy.down('.hitarea').removeClassName('clox');
				}
				if (SourceUrl != TargetUrl) {
					elCopy.writeAttribute('url', SourceUrl);
				}
				if (addInside) {
					addElementInto(elTarget, elCopy);
				} else {
					addElement(elTarget, elCopy, !overFirstHalf);
				}
			}
		} else {
			selectElement(elSource, true);
		}
		$P(document.body).removeClassName('something-is-dragged');
		self.dragEvent.dragSource = null;
		self.dragEvent.dropTarget = null;
		self.dragEvent = null;
	}
	if (pageContainsDraggables) {
		self.dragEvent = null;
		$P(document.body).observe('mouseup', stopDrag);
		$P(document)
			.observe('keypress', function(event) {
				if (!self.dragEvent) { return; }
				var code = event.wich || event.keyCode, dt;
				if (code == Event.KEY_ESC) {
					dt = self.dragEvent.dropTarget;
					if (dt) {
						dt
							.removeClassName("mouse-over-first-half")
							.removeClassName("mouse-over-second-half");
					}
					self.dragEvent.dropTarget = dt = null;
					stopDrag(event);
				}
			});
	}
	if (pageContainsEditables) {
		elementButtons = new Element('span', { 'class' : 'element-buttons' } ).update('<img src="'+serverSkinURL+'images/tree-view/edit/edit.gif" class="edit-button" title=" " /><img src="'+serverSkinURL+'images/tree-view/edit/add.gif" class="add-button" title="  " /><img src="'+serverSkinURL+'images/tree-view/edit/delete.gif" class="delete-button" title=" " />');
	}
	
	/**
	 * documentframe
	 */
	var hasVerticalLayout = false, fIndex = -1, globalFrameIndex = -1;
	var minFrameSize      = 250,  // minFrameSize <= maxFrameSize
	    maxFrameSize      = 500,  //
	    toggledFrameSize  = 24,   // toggledFrameSize << minFrameSize
	    frameResizeDelta  = 50,
	    currentFrameSize  = 300;  // minFrameSize <= currentFrameSize <= maxFrameSize
	function f_isFrameAccessible(frame) {
		try {
			frame.window;
			frame.window.document;
		} catch(error) { return false; }
		return true;
	}
	(function() {
		//   ,   
		for (var i = 0; i < parent.frames.length; ++i) {
			if (f_isFrameAccessible(parent.frames[i]) && parent.frames[i].window == window) {
				globalFrameIndex = i;
				break;
			}
		}
		if (globalFrameIndex == -1) { return; }
		if (!parent.frames[globalFrameIndex].frameElement || (parent.frames[globalFrameIndex].frameElement.nodeName || '').toLowerCase() != 'frame') { return; }
		if ($P(document.body).className.indexOf('document-frame') == -1) { return; }
		//  frameset     frame
		var frameset = eLS.cache.domNodes.frameset = parent.document.getElementsByTagName('frame')[globalFrameIndex].parentNode;
		//   :   
		hasVerticalLayout = !!frameset && !!frameset.cols && !!frameset.cols.length;
		//    frame'a   frameset'a
		var fci = -1;
		var fc = frameset.childNodes;
		var tempDocumentObject;
		//  contentWindow    IE   FF
		// contentDocument   FF
		// contentDocument.defaultView -   window
		for (var i = 0; i < fc.length; ++i) {
			if (fc[i].nodeType == 1
					&& ['frame', 'frameset'].indexOf(fc[i].nodeName.toLowerCase()) != -1) {
				fci++;
				if (fc[i].contentDocument) {
					tempDocumentObject = fc[i].contentDocument;
				} else if (fc[i].contentWindow) {
					tempDocumentObject = fc[i].contentWindow.document;
				} else {
					tempDocumentObject = null;
				}
				if (tempDocumentObject == document) {
					fIndex = fci;
					break;
				}
			}
		}
	})();
	if ($P(document.body).className.indexOf('document-frame') != -1 && fIndex != -1 && hasVerticalLayout) {
		var frameLogo           = $P('main-logo'),
		    b_frameToggler      = $P('frame-collapse-expand'),
		    b_frameSizeIncrease = $P('frame-size-increase'),
		    b_frameSizeDecrease = $P('frame-size-decrease');
		if (!Prototype.Browser.IE) {
			parent.frames[globalFrameIndex].frameElement.setAttribute('scrolling', 'auto');
		}
		function f_framesetGetCols() {
			return eLS.cache.domNodes.frameset
				.cols
				.split(',')
				.invoke('strip');
		}
		function f_framesetSetCols(cols) {
			eLS.cache.domNodes.frameset.cols = cols.join(',');
			var frames = parent.frames;
			for (var i = 0; i < frames.length; i++) {
				if (f_isFrameAccessible(frames[i]) && frames[i].WindowEvent) {
					frames[i].WindowEvent.fire('resize');
				}
			}
		}
		function f_frameGetSize(frameIndex) {
			if (!Object.isNumber(frameIndex) || isNaN(frameIndex) || frameIndex < 0) { return 0; }
			return parseInt(f_framesetGetCols()[frameIndex], 10) || 0;
		}
		function f_frameSetSize(size, frameIndex) {
			var cols = f_framesetGetCols();
			if (!Object.isNumber(frameIndex) || isNaN(frameIndex)
				|| frameIndex < 0 || cols.length <= frameIndex) { return; }
			cols[frameIndex] = (size && size > 0) ? size : 0;
			f_framesetSetCols(cols);
		}
		//     
		//    ,   
		//   [min, max]
		function f_frameGetSizeNew(frameSize, direction) {
			// GLOBAL: minFrameSize
			// GLOBAL: maxFrameSize
			// GLOBAL: frameResizeDelta
			if (direction == 'increase') {
				if (frameSize < maxFrameSize) {
					return frameSize + frameResizeDelta <= maxFrameSize
						? frameSize + frameResizeDelta
						: maxFrameSize;
				}
			} else if (direction == 'decrease') {
				if (frameSize > minFrameSize) {
					return frameSize - frameResizeDelta >= minFrameSize
						? frameSize - frameResizeDelta
						: minFrameSize;
				}
			} else {
				return (frameSize < minFrameSize)
					? minFrameSize
					: ( (frameSize > maxFrameSize) ? minFrameSize : frameSize );
			}
			return frameSize;
		}
		function f_frameIsResizeable(direction) {
			// GLOBAL: b_frameSizeIncrease
			// GLOBAL: b_frameSizeDecrease
			var resizeable = !$P(document.body).hasClassName('forbid-frame-resize');
			if (/increase|decrease/.test(direction) && b_frameSizeIncrease && b_frameSizeDecrease) {
				resizeable = resizeable
					&& !((direction == 'increase' ? b_frameSizeIncrease : b_frameSizeDecrease).hasClassName('disabled'));
			}
			return resizeable;
		}
		function f_frameIsExpanded() {
			// GLOBAL: fIndex
			// GLOBAL: toggledFrameSize
			var frameSize = f_frameGetSize(fIndex);
			return (frameSize == toggledFrameSize) ? false : true;
		}
		function f_frameResize(direction) {
			// GLOBAL: fIndex
			if (!f_frameIsExpanded()) { return; }
			var frameSize = f_frameGetSizeNew(
				f_frameGetSize(fIndex),
				direction
			);
			
			currentFrameSize = frameSize;
			f_frameSetButtons(frameSize);
			f_frameSetSize(frameSize, fIndex);
		}
		function f_frameToggle() {
			f_frameIsExpanded() ? f_frameCollapse() : f_frameExpand();
		}
		function f_frameExpand() {
			if (f_frameIsExpanded()) { return; }
			jQuery('html').removeClass('no-overflow');
			var frameSize = f_frameGetSizeNew(currentFrameSize);
			$P(document.body).removeClassName('collapsed');
			f_frameSetButtons(frameSize);
			f_frameSetSize(frameSize, fIndex);
		}
		function f_frameCollapse() {
			if (!f_frameIsExpanded()) { return; }
			jQuery('html').addClass('no-overflow');
			var frameSize = toggledFrameSize;
			$P(document.body).addClassName('collapsed');
			f_frameSetButtons(frameSize);
			f_frameSetSize(frameSize, fIndex);
		}
		// UI features
		function f_frameSetButtons(frameSize) {
			// GLOBAL: b_frameSizeIncrease
			// GLOBAL: b_frameSizeDecrease
			// GLOBAL: minFrameSize
			// GLOBAL: maxFrameSize
			if (b_frameSizeIncrease && b_frameSizeDecrease) {
				if (frameSize >= maxFrameSize || frameSize == toggledFrameSize) {
					b_frameSizeIncrease.addClassName('disabled');
				} else {
					b_frameSizeIncrease.removeClassName('disabled');
				}
				if (frameSize <= minFrameSize || frameSize == toggledFrameSize) {
					b_frameSizeDecrease.addClassName('disabled');
				} else {
					b_frameSizeDecrease.removeClassName('disabled');
				}
			}
			if (b_frameToggler) {
				if (frameSize == toggledFrameSize) {
					b_frameToggler
						.removeClassName('collapse')
						.addClassName('expand');
				} else {
					b_frameToggler
						.removeClassName('expand')
						.addClassName('collapse');
				}
			}
		}
		function f_frameSetEnabled(enable) {
			if (Object.isUndefined(enable) || enable) {
				$P(document.body).removeClassName('forbid-frame-resize');
			} else {
				$P(document.body).addClassName('forbid-frame-resize');
			}
		}
		function f_frameSetDisabled() {
			return f_frameSetEnabled(false);
		}

		//      
		if (frameLogo) {
			var image = frameLogo.getElementsByTagName('img')[0];
			if (image && image.src) {
				image = $P(image);
				eLS.utils.ImagesPreload.add(image.src, 'main-logo', {
					onload: function(imageObject) {
						// - - 
						image.getStyle('margin-left');
						var newSize = (parseInt(image.getStyle('margin-left'), 10) || 0)
							+ (parseInt(image.getStyle('margin-right'), 10) || 0)
							+ image.cumulativeOffset().left
							+ imageObject.width;
							
						minFrameSize = f_frameGetSizeNew(newSize);
						f_frameResize();
					},
					onerror: function() {
						f_frameResize();
					}
				});
			}
		} else {
			f_frameResize();
		}
		
		if (b_frameSizeDecrease && b_frameSizeIncrease) {
			[b_frameSizeDecrease, b_frameSizeIncrease]
				.invoke('observe', 'click', function(event) {
					var direction = (this.id == 'frame-size-increase') ? 'increase' : 'decrease';
					if (!f_frameIsResizeable(direction)) { return; }
					f_frameResize(direction);
				});
		}
		if (b_frameToggler) {
			eLS.utils.ImagesPreload.add(serverSkinURL+'images/frame/expand.gif', 'frame-controller');
			b_frameToggler.observe('click', function() {
				if (!f_frameIsResizeable()) { return; }
				f_frameToggle();
			});
		}
		
		eLS.utils.frame = {
			sizeIncrease: function() {
				var direction = 'increase';
				if (!f_frameIsResizeable(direction)) { return false; }
				f_frameResize(direction);
				return true;
			},
			sizeDecrease: function() {
				var direction = 'decrease';
				if (!f_frameIsResizeable(direction)) { return false; }
				f_frameResize(direction);
				return true;
			},
			collapse: function(force) {
				if (!f_frameIsResizeable()) { return false; }
				f_frameCollapse();
				return true;
			},
			expand: function(force) {
				if (!f_frameIsResizeable()) { return false; }
				f_frameExpand();
				return true;
			},
			disable: function() {
				f_frameSetDisabled();
			},
			enable: function() {
				f_frameSetEnabled();
			}
		};
	}

	window.eLS.isDOMLoaded = true;

	WindowEvent.fire('resize');
}
Event.observe(window, 'load', function() { WindowEvent.fire('resize'); });
$P(document).observe('dom:loaded', DOMContentLoadedCallback);

$P(document).observe('dom:loaded', function(event) {
	var buttons = $('.button');
	var tpl = new Template([
		'<input type="#{type}"',
		'	name="#{name}"',
		'	value="#{value}"',
		'	onclick=\'#{onclick}\'',
		' />'
	].join('\n'));
	
	if (window.isOfflineMode) {
		return;
	}
	
	function processToStringFunction(func) {
		var fstr = (func || '').toString();
		return  fstr.replace(/^function\s+(onclick|anonymous)\s?\(.*\)/i, '');
	}
	function esc(str) {
		return (str || '').replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;").replace(/'/g, "&apos;");
	}
	
	$.each(buttons, function() {
		var submit = $P(this).next('input[type=button], input[type=submit]');
		if (submit) {
			var $this = $(this),
			    $submit = $(submit),
			    $a = $this.find('a'),
			    ahref = $a.attr('href') || '',
			    content = tpl.evaluate({
			    	value: $a.html(),
			    	onclick: String(
			    		/^javascript:/.test(ahref)
			    			? /void/.test(ahref)
			    				? (processToStringFunction($this.attr('onclick')) || processToStringFunction($a.attr('onclick')) || '')
			    				: ahref.replace(/^javascript:/, '')
			    			: ('document.location.href = &quot;' + esc(ahref) + '&quot;; return false;')
			    		),
			    	type: $submit.attr('type') || 'submit',
			    	name: $submit.attr('name') || ''
			    });
			
			$(this).replaceWith(content);
		}
	});
});

$P(document).observe('dom:loaded', function(event) {
	var textareas = $('.oldstyle textarea');
	$.each(textareas, function() {
		var $this = $(this);
		if ($this.css('width') != '100%') {
			return;
		}
		$this
			.addClass('wrappedtextarea')
			.wrap('<div class="textareawrapper"></div>');
	});
});
$P(document).observe('dom:loaded', function(event) {
	$('table.main')
		.removeAttr('cellspacing')
		.removeAttr('cellpadding');
});

$P(document).observe('dom:loaded', function(event) {
	try {
		$('.eLS-panel-header')
			.prepend('<div class="eLS-panel-toogle-button"><a href="#"><span></span></a></div>')
			.find('.eLS-panel-toogle-button')
			.click(function(event) {
				var element = $P(this).up('.eLS-panel');
				var toggled = $P(element).down('.eLS-panel-content');

				new Effect.toggle(toggled, 'blind', {
					afterFinish: function (effect) {
						var target = effect.element.up('.eLS-panel');
						if (effect.element.visible()) {
							$(target)
								.removeClass('eLS-panel-closed');
						} else {
							$(target)
								.addClass('eLS-panel-closed');
						}
						WindowEvent.fire('resize');
					},
					duration: 0.3,
					queue: {scope: '.user-menu'}
				});
				
				return false;
			});
	} catch (error) {
	}
	
	/* var userMenu = $P('user-menu');
	if (userMenu) {
		var onClickUserMenu = function(event) {
			if (self.Effect && Effect.Queues.get('.user-menu').effects.length > 0) { return; }
			var target = $P(event.element());
			if (!target || !target.match('.tb-actions')) { return; }
			var element = target.up('div.wrapper').down('.user-actions');
			if (!element) { return; }
			event.stop();
			if (self.Effect) {
				new Effect.toggle(element, 'blind', {
					afterFinish: function (effect) {
						var target = effect.element.up().down('.tb-actions');
						if (effect.element.visible()) {
							target
								.removeClassName('tb-actions-open')
								.addClassName('tb-actions-close');
						} else {
							target
								.removeClassName('tb-actions-close')
								.addClassName('tb-actions-open');
						}
						WindowEvent.fire('resize');
					},
					duration: 0.3,
					queue: {scope: '.user-menu'}
				});
			} else {
				element.visible() ? (function() {element.hide(); target.removeClassName('tb-actions-close').addClassName('tb-actions-open');})() : (function() { element.show(); target.removeClassName('tb-actions-open').addClassName('tb-actions-close'); })();
				WindowEvent.fire('resize');
			}
		}
		userMenu
			.observe('click', onClickUserMenu)
			.observe('keypress', function(event) {
				if (!isEnterKey(event)) { return; }
				onClickUserMenu(event);
			});
		*/
});


})();

WindowEvent.observe('unload', function() {
	for (var member in eLS.cache.domNodes) {
		eLS.cache.domNodes[member] = null;
	}
	WindowEvent.destroy();
	eLS.utils.ImagesPreload.unload();
});

